// Numerical Recipes in C++, 2nd edition, pg. 56

#include <cmath>
int assume(bool);
int static_assert(bool);
int unknown();
using namespace std;

void
function(int n, int m1, int m2)
{
  assume(m1 >= 0);
  assume(m2 >= 0);  
  assume(n >= m1 + m2 + 1);  

  int a_dim1 = n;
  int a_dim2 = m1 + m2 + 1;
  int al_dim1 = n;
  int al_dim2 = m1;  
  int indx_dim1 = n;

  //const DP TINY = 1.0e-20;
  int i, j, k, l, mm;
  //DP dum;

  mm = m1 + m2 + 1;
  l = m1;
  for (i = 0; i < m1; i++)
    {
      for (j = m1 - i; j < mm; j++)
	{
	  //a[i][j - l] = a[i][j];
	  //static_assert(0 <= i);
	  //static_assert(i < a_dim1);
	  //static_assert(0 <= j - l);
	  //static_assert(j - l < a_dim2);
	  //static_assert(0 <= i);
	  //static_assert(i < a_dim1);
	  //static_assert(0 <= j);
	  //static_assert(j < a_dim2);
	}
      l--;
      for (j = mm - l - 1; j < mm; j++)
	{
	  //a[i][j] = 0.0;
	  //static_assert(0 <= i);
	  //static_assert(i < a_dim1);
	  //static_assert(0 <= j);
	  //static_assert(j < a_dim2);
	}
    }
  // d = 1.0;
  l = m1;
  for (k = 0; k < n; k++)
    {
      //dum = a[k][0];
      //static_assert(0 <= k);
      //static_assert(k < a_dim1);
      //static_assert(0 <= 0);
      //static_assert(0 < a_dim2);
      i = k;
      if (l < n)
	{
	  l++;
	}
      for (j = k + 1; j < l; j++)
	{
	  //static_assert(0 <= j);
	  //static_assert(j < a_dim1);
	  //static_assert(0 <= 0);
	  //static_assert(0 < a_dim2);
	  if (unknown() /*fabs(a[j][0]) > fabs(dum)*/)
	  {
	    //dum = a[j][0];
	    //static_assert(0 <= j);
	    //static_assert(j < a_dim1);
	    //static_assert(0 <= 0);
	    //static_assert(0 < a_dim2);
	    i = j;
	  }
	}
      //indx[k] = i + 1;
      //static_assert(0 <= k);
      //static_assert(k < indx_dim1);
      if (unknown()/*dum == 0.0*/)
	{
	  //a[k][0] = TINY;
	  //static_assert(0 <= k);
	  //static_assert(k < a_dim1);
	  //static_assert(0 <= 0);
	  //static_assert(0 < a_dim2);
	}
      if (i != k)
	{
	  // d = -d;
	  for (j = 0; j < mm; j++)
	    {
	      //SWAP(a[k][j], a[i][j]);
	      //static_assert(0 <= k);
	      //static_assert(k < a_dim1);
	      //static_assert(0 <= j);
	      //static_assert(j < a_dim2);
	      //static_assert(0 <= i);
	      //static_assert(i < a_dim1);
	      //static_assert(0 <= j);
	      //static_assert(j < a_dim2);
	    }
	}
      for (i = k + 1; i < l; i++)
	{
	  //dum = a[i][0] / a[k][0];
	  //static_assert(0 <= i);
	  //static_assert(i < a_dim1);
	  //static_assert(0 <= 0);
	  //static_assert(0 < a_dim2);
	  //static_assert(0 <= k);
	  //static_assert(k < a_dim1);
	  //static_assert(0 <= 0);
	  //static_assert(0 < a_dim2);
	  //al[k][i - k - 1] = dum;
	  //static_assert(0 <= k);
	  //static_assert(k < al_dim1);
	  //static_assert(0 <= i - k - 1);
	  //static_assert(i - k - 1 < al_dim2);
	  for (j = 1; j < mm; j++)
	    {
	      //a[i][j - 1] = a[i][j] - dum * a[k][j];
	      //static_assert(0 <= i);
	      //static_assert(i < a_dim1);
	      //static_assert(0 <= j - 1);
	      static_assert(j - 1 < a_dim2);
	      //static_assert(0 <= i);
	      //static_assert(i < a_dim1);
	      //static_assert(0 <= j);
	      //static_assert(j < a_dim2);
	      //static_assert(0 <= k);
	      //static_assert(k < a_dim1);
	      //static_assert(0 <= j);
	      //static_assert(j < a_dim2);
	    }
	  //a[i][mm - 1] = 0.0;
	  //static_assert(0 <= i);
	  //static_assert(i < a_dim1);
	  //static_assert(0 <= mm - 1);
	  //static_assert(mm - 1 < a_dim2);
	}
    }
}
