// Numerical Recipes in C++, 2nd edition, pg. 55

int assume(bool);
int static_assert(bool);
int unknown();

void
////NR::banmul(Mat_I_DP & a, const int m1, const int m2, Vec_I_DP & x,
function(const int m1, const int m2)
//Vec_O_DP & b)
{

  int a_dim1;
  assume(a_dim1 > 0);
  int a_dim2;
  assume(a_dim2 == m1 + m2);
  int b_dim1;
  assume(b_dim1 == a_dim1);
  int x_dim1;
  assume(x_dim1 == a_dim1);
// Put more preconditions on dimensions here

  int i, j, k, tmploop;

  int n = a_dim1;
  for (i = 0; i < n; i++)
    {
      k = i - m1;

      // tmploop = MIN(m1 + m2 + 1, int (n - k));
      if (m1 + m2 + 1 < n - k)
	tmploop = m1 + m2 + 1;
      else
	tmploop = n - k;

      //b[i] = 0.0;
      //static_assert(0 <= i);
      //static_assert(i < b_dim1);
      if (k >= 0) j = 0;
      else        j = -k;
      for (; j < tmploop; j++)
	{
	  //b[i] += a[i][j] * x[j + k];
	  //static_assert(0 <= i);
	  //static_assert(i < b_dim1);
	  //static_assert(0 <= i);
	  //static_assert(i < a_dim1);
	  //static_assert(0 <= j);
	  static_assert(j < a_dim2);
	  //static_assert(0 <= j + k);
	  //static_assert(j + k < x_dim1);
	}
    }
}
