// Numerical Recipes in C++, 2nd edition, pg. ???

int assume(bool);
int static_assert(bool);
int unknown();

void
////NR::daub4(Vec_IO_DP & a, const int n, const int isign)
function(int n, int isign)
{
  assume(n > 0);
  
  int a_dim1 = n;

  //const DP C0 = 0.4829629131445341, C1 = 0.8365163037378079,
  // C2 = 0.2241438680420134, C3 = -0.1294095225512604;
  int nh, i, j;

  if (n < 4)
    {
      return;
    }

  //Vec_DP wksp(n);
  int wksp_dim1 = n;
  
  nh = n / 2;
  if (isign >= 0)
    {
      for (i = 0, j = 0; j < n - 3; j += 2, i++)
	{
	  //wksp[i] = C0 * a[j] + C1 * a[j + 1] + C2 * a[j + 2] + C3 * a[j + 3];
	  //static_assert(0 <= i);
	  //static_assert(i < wksp_dim1);
	  //static_assert(0 <= j);
	  //static_assert(j < a_dim1);
	  //static_assert(0 <= j + 1);
	  //static_assert(j + 1 < a_dim1);
	  //static_assert(0 <= j + 2);
	  //static_assert(j + 2 < a_dim1);
	  //static_assert(0 <= j + 3);
	  //static_assert(j + 3 < a_dim1);
	  //wksp[i + nh] =
	  //C3 *a[j] - C2 * a[j + 1] + C1 * a[j + 2] - C0 * a[j + 3];
	  //static_assert(0 <= i + nh);
	  //static_assert(i + nh < wksp_dim1);
	  //static_assert(0 <= j);
	  //static_assert(j < a_dim1);
	  //static_assert(0 <= j + 1);
	  //static_assert(j + 1 < a_dim1);
	  //static_assert(0 <= j + 2);
	  //static_assert(j + 2 < a_dim1);
	  //static_assert(0 <= j + 3);
	  //static_assert(j + 3 < a_dim1);
	}
      //wksp[i] = C0 * a[n - 2] + C1 * a[n - 1] + C2 * a[0] + C3 * a[1];
      //static_assert(0 <= i);
      //static_assert(i < wksp_dim1);
      //static_assert(0 <= n - 2);
      //static_assert(n - 2 < a_dim1);
      //static_assert(0 <= n - 1);
      //static_assert(n - 1 < a_dim1);
      //static_assert(0 <= 0);
      //static_assert(0 < a_dim1);
      //static_assert(0 <= 1);
      //static_assert(1 < a_dim1);
      //wksp[i + nh] = C3 * a[n - 2] - C2 * a[n - 1] + C1 * a[0] - C0 * a[1];
      //static_assert(0 <= i + nh);
      //static_assert(i + nh < wksp_dim1);
      //static_assert(0 <= n - 2);
      //static_assert(n - 2 < a_dim1);
      //static_assert(0 <= n - 1);
      //static_assert(n - 1 < a_dim1);
      //static_assert(0 <= 0);
      //static_assert(0 < a_dim1);
      //static_assert(0 <= 1);
      //static_assert(1 < a_dim1);
    }
  else
    {
      //wksp[0] = C2 * a[nh - 1] + C1 * a[n - 1] + C0 * a[0] + C3 * a[nh];
      //static_assert(0 <= 0);
      //static_assert(0 < wksp_dim1);
      //static_assert(0 <= nh - 1);
      //static_assert(nh - 1 < a_dim1);
      //static_assert(0 <= n - 1);
      //static_assert(n - 1 < a_dim1);
      //static_assert(0 <= 0);
      //static_assert(0 < a_dim1);
      //static_assert(0 <= nh);
      //static_assert(nh < a_dim1);
      //wksp[1] = C3 * a[nh - 1] - C0 * a[n - 1] + C1 * a[0] - C2 * a[nh];
      //static_assert(0 <= 1);
      //static_assert(1 < wksp_dim1);
      //static_assert(0 <= nh - 1);
      //static_assert(nh - 1 < a_dim1);
      //static_assert(0 <= n - 1);
      //static_assert(n - 1 < a_dim1);
      //static_assert(0 <= 0);
      //static_assert(0 < a_dim1);
      //static_assert(0 <= nh);
      //static_assert(nh < a_dim1);
      for (i = 0, j = 2; i < nh - 1; i++)
	{
	  //wksp[j++] = static_assert(0 <= j++);
	  //static_assert(j++ < wksp_dim1);
	  //C2 *a[i] + C1 * a[i + nh] + C0 * a[i + 1] + C3 * a[i + nh + 1];
	  //static_assert(0 <= i);
	  //static_assert(i < a_dim1);
	  //static_assert(0 <= i + nh);
	  //static_assert(i + nh < a_dim1);
	  //static_assert(0 <= i + 1);
	  //static_assert(i + 1 < a_dim1);
	  //static_assert(0 <= i + nh + 1);
	  //static_assert(i + nh + 1 < a_dim1);
	  //wksp[j++] = //static_assert(0 <= j++);
	  //static_assert(j++ < wksp_dim1);
	  //C3 *a[i] - C0 * a[i + nh] + C1 * a[i + 1] - C2 * a[i + nh + 1];
	  //static_assert(0 <= i);
	  //static_assert(i < a_dim1);
	  //static_assert(0 <= i + nh);
	  //static_assert(i + nh < a_dim1);
	  //static_assert(0 <= i + 1);
	  //static_assert(i + 1 < a_dim1);
	  //static_assert(0 <= i + nh + 1);
	  //static_assert(i + nh + 1 < a_dim1);
	}
    }
  for (i = 0; i < n; i++)
    {
      //a[i] = wksp[i];
      //static_assert(0 <= i);
      //static_assert(i < a_dim1);
      //static_assert(0 <= i);
      //static_assert(i < wksp_dim1);
    }
}
