// Numerical Recipes in C++, 2nd edition, pg. 432

#include <cmath>
#include <limits>
int assume(bool);
int static_assert(bool);
int unknown();
using namespace std;

void function()
//NR::dfpmin(Vec_IO_DP & p, const DP gtol, int &iter, DP & fret,
//DP func(Vec_I_DP &), void dfunc(Vec_I_DP &, Vec_O_DP &))
{
  int p_dim1;
  assume(p_dim1 > 0);

  const int ITMAX = 200;
  //const DP EPS = numeric_limits < DP >::epsilon();
  //const DP TOLX = 4 * EPS, STPMX = 100.0;
  // bool check;
  int i, its, j;
  //DP den, fac, fad, fae, fp, stpmax, sum = 0.0, sumdg, sumxi, temp, test;

  int n = p_dim1;
  //Vec_DP dg(n), g(n), hdg(n), pnew(n), xi(n);
  //Mat_DP hessin(n, n);
  int dg_dim1 = n;
  int g_dim1 = n;
  int hdg_dim1 = n;
  int hessin_dim1 = n;
  int hessin_dim2 = n;
  int pnew_dim1 = n;
  int xi_dim1 = n;

  // fp = func(p);
  // dfunc(p, g);
  for (i = 0; i < n; i++)
    {
      for (j = 0; j < n; j++)
	{
	  //hessin[i][j] = 0.0;
	  //static_assert(0 <= i);
	  //static_assert(i < hessin_dim1);
	  //static_assert(0 <= j);
	  //static_assert(j < hessin_dim2);
	}
      //hessin[i][i] = 1.0;
      //static_assert(0 <= i);
      //static_assert(i < hessin_dim1);
      //static_assert(0 <= i);
      //static_assert(i < hessin_dim2);
      //xi[i] = -g[i];
      //static_assert(0 <= i);
      //static_assert(i < xi_dim1);
      //static_assert(0 <= i);
      //static_assert(i < g_dim1);
      //sum += p[i] * p[i];
      //static_assert(0 <= i);
      //static_assert(i < p_dim1);
      //static_assert(0 <= i);
      //static_assert(i < p_dim1);
    }
  //stpmax = STPMX * MAX(sqrt(sum), DP(n));
  for (its = 0; its < ITMAX; its++)
    {
      // iter = its;
      // lnsrch(p, fp, g, xi, pnew, fret, stpmax, check, func);
      // fp = fret;
      for (i = 0; i < n; i++)
	{
	  //xi[i] = pnew[i] - p[i];
	  //static_assert(0 <= i);
	  //static_assert(i < xi_dim1);
	  //static_assert(0 <= i);
	  //static_assert(i < pnew_dim1);
	  //static_assert(0 <= i);
	  //static_assert(i < p_dim1);
	  //p[i] = pnew[i];
	  //static_assert(0 <= i);
	  //static_assert(i < p_dim1);
	  //static_assert(0 <= i);
	  //static_assert(i < pnew_dim1);
	}
      // test = 0.0;
      for (i = 0; i < n; i++)
	{
	  //temp = fabs(xi[i]) / MAX(fabs(p[i]), 1.0);
	  //static_assert(0 <= i);
	  //static_assert(i < xi_dim1);
	  //static_assert(0 <= i);
	  //static_assert(i < p_dim1);
	  // if (temp > test)
	  //   {
	  //     test = temp;
	  //   }
	}
      // if (test < TOLX)
      // 	{
      // 	  return;
      // 	}
      for (i = 0; i < n; i++)
	{
	  //dg[i] = g[i];
	  //static_assert(0 <= i);
	  //static_assert(i < dg_dim1);
	  //static_assert(0 <= i);
	  //static_assert(i < g_dim1);
	}
      // dfunc(p, g);
      // test = 0.0;
      // den = MAX(fret, 1.0);
      for (i = 0; i < n; i++)
	{
	  //temp = fabs(g[i]) * MAX(fabs(p[i]), 1.0) / den;
	  //static_assert(0 <= i);
	  //static_assert(i < g_dim1);
	  //static_assert(0 <= i);
	  //static_assert(i < p_dim1);
	  // if (temp > test)
	  //   {
	  //     test = temp;
	  //   }
	}
      // if (test < gtol)
      // 	{
      // 	  return;
      // 	}
      for (i = 0; i < n; i++)
	{
	  //dg[i] = g[i] - dg[i];
	  //static_assert(0 <= i);
	  //static_assert(i < dg_dim1);
	  //static_assert(0 <= i);
	  //static_assert(i < g_dim1);
	  //static_assert(0 <= i);
	  //static_assert(i < dg_dim1);
	}
      for (i = 0; i < n; i++)
	{
	  //hdg[i] = 0.0;
	  //static_assert(0 <= i);
	  //static_assert(i < hdg_dim1);
	  for (j = 0; j < n; j++)
	    {
	      //hdg[i] += hessin[i][j] * dg[j];
	      //static_assert(0 <= i);
	      //static_assert(i < hdg_dim1);
	      //static_assert(0 <= i);
	      //static_assert(i < hessin_dim1);
	      //static_assert(0 <= j);
	      //static_assert(j < hessin_dim2);
	      //static_assert(0 <= j);
	      //static_assert(j < dg_dim1);
	    }
	}
      // fac = fae = sumdg = sumxi = 0.0;
      for (i = 0; i < n; i++)
	{
	  //fac += dg[i] * xi[i];
	  //static_assert(0 <= i);
	  //static_assert(i < dg_dim1);
	  //static_assert(0 <= i);
	  //static_assert(i < xi_dim1);
	  //fae += dg[i] * hdg[i];
	  //static_assert(0 <= i);
	  //static_assert(i < dg_dim1);
	  //static_assert(0 <= i);
	  //static_assert(i < hdg_dim1);
	  //sumdg += SQR(dg[i]);
	  //static_assert(0 <= i);
	  static_assert(i < dg_dim1);
	  //sumxi += SQR(xi[i]);
	  //static_assert(0 <= i);
	  //static_assert(i < xi_dim1);
	}
      if (unknown() /*fac > sqrt(EPS * sumdg * sumxi)*/)
      {
	// fac = 1.0 / fac;
	// fad = 1.0 / fae;
	for (i = 0; i < n; i++)
	  {
	    //dg[i] = fac * xi[i] - fad * hdg[i];
	    //static_assert(0 <= i);
	    //static_assert(i < dg_dim1);
	    //static_assert(0 <= i);
	    //static_assert(i < xi_dim1);
	    //static_assert(0 <= i);
	    //static_assert(i < hdg_dim1);
	  }
	for (i = 0; i < n; i++)
	  {
	    for (j = i; j < n; j++)
	      {
		//hessin[i][j] += fac * xi[i] * xi[j]
		// -fad * hdg[i] * hdg[j] + fae * dg[i] * dg[j];

		//static_assert(0 <= i);
		//static_assert(i < hessin_dim1);
		//static_assert(0 <= j);
		//static_assert(j < hessin_dim2);
		//static_assert(0 <= i);
		//static_assert(i < xi_dim1);
		//static_assert(0 <= j);
		//static_assert(j < xi_dim1);

		//static_assert(0 <= i);
		//static_assert(i < hdg_dim1);
		//static_assert(0 <= j);
		//static_assert(j < hdg_dim1);
		//static_assert(0 <= i);
		//static_assert(i < dg_dim1);
		//static_assert(0 <= j);
		//static_assert(j < dg_dim1);

		//hessin[j][i] = hessin[i][j];
		//static_assert(0 <= j);
		//static_assert(j < hessin_dim1);
		//static_assert(0 <= i);
		//static_assert(i < hessin_dim2);
		//static_assert(0 <= i);
		//static_assert(i < hessin_dim1);
		//static_assert(0 <= j);
		//static_assert(j < hessin_dim2);
	      }
	  }
      }
      for (i = 0; i < n; i++)
	{
	  //xi[i] = 0.0;
	  //static_assert(0 <= i);
	  //static_assert(i < xi_dim1);
	  for (j = 0; j < n; j++)
	    {
	      //xi[i] -= hessin[i][j] * g[j];
	      //static_assert(0 <= i);
	      //static_assert(i < xi_dim1);
	      //static_assert(0 <= i);
	      //static_assert(i < hessin_dim1);
	      //static_assert(0 <= j);
	      //static_assert(j < hessin_dim2);
	      //static_assert(0 <= j);
	      //static_assert(j < g_dim1);
	    }
	}
    }
  // nrerror("too many iterations in dfpmin");
}
