// Numerical Recipes in C++, 2nd edition, pg. 159

#include <cmath>
int assume(bool);
int static_assert(bool);
int unknown();
using namespace std;

void
////NR::gauher(Vec_O_DP & x, Vec_O_DP & w)
function()
{
  int x_dim1;
  assume(x_dim1 > 0);
  int w_dim1;
  assume(w_dim1 == x_dim1);

  //const DP EPS = 1.0e-14, PIM4 = 0.7511255444649425;
  const int MAXIT = 10;
  int i, its, j, m;
  //DP p1, p2, p3, pp, z, z1;

  int n = x_dim1;
  m = (n + 1) / 2;
  for (i = 0; i < m; i++)
    {
      if (i == 0)
	{
	  //z = sqrt(DP(2 * n + 1)) - 1.85575 * pow(DP(2 * n + 1), -0.16667);
	}
      else if (i == 1)
	{
	  //z -= 1.14 * pow(DP(n), 0.426) / z;
	}
      else if (i == 2)
	{
	  //z = 1.86 * z - 0.86 * x[0];
	  //static_assert(0 <= 0);
	  //static_assert(0 < x_dim1);
	}
      else if (i == 3)
	{
	  //z = 1.91 * z - 0.91 * x[1];
	  //static_assert(0 <= 1);
	  //static_assert(1 < x_dim1);
	}
      else
	{
	  //z = 2.0 * z - x[i - 2];
	  //static_assert(0 <= i - 2);
	  //static_assert(i - 2 < x_dim1);
	}
      for (its = 0; its < MAXIT; its++)
	{
	  // p1 = PIM4;
	  // p2 = 0.0;
	  for (j = 0; j < n; j++)
	    {
	      // p3 = p2;
	      // p2 = p1;
	      //p1 = z * sqrt(2.0 / (j + 1)) * p2 - sqrt(DP(j) / (j + 1)) * p3;
	    }
	  //pp = sqrt(DP(2 * n)) * p2;
	  // z1 = z;
	  // z = z1 - p1 / pp;
	  if (unknown() /*fabs(z - z1) <= EPS*/)
	    {
	      break;
	    }
	}
      if (its >= MAXIT)
	{
	  return;
	  // nrerror("too many iterations in gauher");
	}
      //x[i] = z;
      //static_assert(0 <= i);
      //static_assert(i < x_dim1);
      //x[n - 1 - i] = -z;
      //static_assert(0 <= n - 1 - i);
      //static_assert(n - 1 - i < x_dim1);
      //w[i] = 2.0 / (pp * pp);
      //static_assert(0 <= i);
      //static_assert(i < w_dim1);
      //w[n - 1 - i] = w[i];
      //static_assert(0 <= n - 1 - i);
      //static_assert(n - 1 - i < w_dim1);
      static_assert(0 <= i);
      //static_assert(i < w_dim1);
    }
}
