// Numerical Recipes in C++, 2nd edition, pg. 882

int assume(bool);
int static_assert(bool);
int unknown();

void
////NR::interp(Mat_O_DP & uf, Mat_I_DP & uc)
function()
{
  int uc_dim1;
  int uc_dim2;

  int uf_dim1;
  assume(uf_dim1 > 0);
  int uf_dim2;
  assume(uf_dim2 == uf_dim1);

  int ic, iif, jc, jf, nc;

  int nf = uf_dim1;
  nc = nf / 2 + 1;

  assume(uc_dim1 == nc);
  assume(uc_dim2 == nc);

  for (jc = 0; jc < nc; jc++)
    for (ic = 0; ic < nc; ic++)
      {
	//uf[2 * ic][2 * jc] = uc[ic][jc];
	//static_assert(0 <= 2 * ic);
	// //static_assert(2 * ic < uf_dim1);  // This may be false when nf is even!
	//static_assert(0 <= 2 * jc);
	// //static_assert(2 * jc < uf_dim2);  // This may be false when nf is even!
	//static_assert(0 <= ic);
	//static_assert(ic < uc_dim1);
	//static_assert(0 <= jc);
	//static_assert(jc < uc_dim2);
      }
  for (jf = 0; jf < nf; jf += 2)
    for (iif = 1; iif < nf - 1; iif += 2)
      {
	//uf[iif][jf] = 0.5 * (uf[iif + 1][jf] + uf[iif - 1][jf]);
	//static_assert(0 <= iif);
	//static_assert(iif < uf_dim1);
	//static_assert(0 <= jf);
	//static_assert(jf < uf_dim2);
	static_assert(0 <= iif + 1);
	//static_assert(iif + 1 < uf_dim1);
	//static_assert(0 <= jf);
	//static_assert(jf < uf_dim2);
	//static_assert(0 <= iif - 1);
	//static_assert(iif - 1 < uf_dim1);
	//static_assert(0 <= jf);
	//static_assert(jf < uf_dim2);
      }
  for (jf = 1; jf < nf - 1; jf += 2)
    for (iif = 0; iif < nf; iif++)
      {
	//uf[iif][jf] = 0.5 * (uf[iif][jf + 1] + uf[iif][jf - 1]);
	//static_assert(0 <= iif);
	//static_assert(iif < uf_dim1);
	//static_assert(0 <= jf);
	//static_assert(jf < uf_dim2);
	//static_assert(0 <= iif);
	//static_assert(iif < uf_dim1);
	//static_assert(0 <= jf + 1);
	//static_assert(jf + 1 < uf_dim2); // Proving this needs a higher timeout (e.g. 30)
	//static_assert(0 <= iif);
	//static_assert(iif < uf_dim1);
	//static_assert(0 <= jf - 1);
	//static_assert(jf - 1 < uf_dim2);
      }
}
