// Numerical Recipes in C++, 2nd edition, pg. 679

int assume(bool);
int static_assert(bool);
int unknown();

void
////NR::lfit(Vec_I_DP & x, Vec_I_DP & y, Vec_I_DP & sig, Vec_IO_DP & a,
function()
//Vec_I_BOOL & ia, Mat_O_DP & covar, DP & chisq,
//void funcs(const DP, Vec_O_DP &))
{

  int x_dim1;
  assume(x_dim1 > 0);
  int y_dim1;
  assume(y_dim1 == x_dim1);
  int sig_dim1;
  assume(sig_dim1 == x_dim1);
  int a_dim1;
  assume(a_dim1 > 0);
  int ia_dim1;
  assume(ia_dim1 == a_dim1);
  int covar_dim1;
  assume(covar_dim1 == a_dim1);
  int covar_dim2;
  assume(covar_dim2 == a_dim1);

  int i, j, k, l, m, mfit = 0;
  //DP ym, wt, sum, sig2i;

  int ndat = x_dim1;
  int ma = a_dim1;
  //Vec_DP afunc(ma);
  int afunc_dim1 = ma;

  //Mat_DP beta(ma, 1);
  int beta_dim1 = ma;
  int beta_dim2 = 1;

  for (j = 0; j < ma; j++) {
    //static_assert(0 <= j);
    //static_assert(j < ia_dim1);
    if (unknown() /*ia[j]*/)
      {
	mfit++;
      }
  }
  if (mfit == 0)
    {
      // nrerror("lfit: no parameters to be fitted");
      return;
    }
  for (j = 0; j < mfit; j++)
    {
      for (k = 0; k < mfit; k++)
	{
	  //covar[j][k] = 0.0;
	  //static_assert(0 <= j);
	  //static_assert(j < covar_dim1);
	  //static_assert(0 <= k);
	  //static_assert(k < covar_dim2);
	}
      //beta[j][0] = 0.0;
      //static_assert(0 <= j);
      //static_assert(j < beta_dim1);
      //static_assert(0 <= 0);
      //static_assert(0 < beta_dim2);
    }
  for (i = 0; i < ndat; i++)
    {
      //funcs(x[i], afunc);
      //static_assert(0 <= i);
      //static_assert(i < x_dim1);
      //ym = y[i];
      //static_assert(0 <= i);
      //static_assert(i < y_dim1);
      if (mfit < ma)
	{
	  for (j = 0; j < ma; j++) {
	    //static_assert(0 <= j);
	    //static_assert(j < ia_dim1);
	    if (unknown() /*!ia[j]*/)
	      {
		//ym -= a[j] * afunc[j];
		//static_assert(0 <= j);
		//static_assert(j < a_dim1);
		//static_assert(0 <= j);
		//static_assert(j < afunc_dim1);
	      }
	  }
	}
      //sig2i = 1.0 / SQR(sig[i]);
      //static_assert(0 <= i);
      //static_assert(i < sig_dim1);
      for (j = 0, l = 0; l < ma; l++)
	{
	  //static_assert(0 <= l);
	  //static_assert(l < ia_dim1);
	  if (unknown() /*ia[l]*/)
	    {
	      //wt = afunc[l] * sig2i;
	      //static_assert(0 <= l);
	      //static_assert(l < afunc_dim1);
	      for (k = 0, m = 0; m <= l; m++) {
		//static_assert(0 <= m);
		//static_assert(m < ia_dim1);
		if (unknown() /*ia[m]*/)
		  {
		    //covar[j][k] += wt * afunc[m];
		    //static_assert(0 <= j);
		    //static_assert(j < covar_dim1);
		    //static_assert(0 <= k);
		    //static_assert(k < covar_dim2);
		    //static_assert(0 <= m);
		    //static_assert(m < afunc_dim1);
		    k++;
		  }
	      }
	      //beta[j][0] += ym * wt;
	      //static_assert(0 <= j);
	      //static_assert(j < beta_dim1);
	      //static_assert(0 <= 0);
	      //static_assert(0 < beta_dim2);
	      j++;
	    }
	}
    }
  for (j = 1; j < mfit; j++)
    for (k = 0; k < j; k++)
      {
	//covar[k][j] = covar[j][k];
	//static_assert(0 <= k);
	//static_assert(k < covar_dim1);
	//static_assert(0 <= j);
	//static_assert(j < covar_dim2);
	//static_assert(0 <= j);
	//static_assert(j < covar_dim1);
	//static_assert(0 <= k);
	//static_assert(k < covar_dim2);
      }
  //Mat_DP temp(mfit, mfit);
  int temp_dim1 = mfit;
  int temp_dim2 = mfit;

  for (j = 0; j < mfit; j++)
    for (k = 0; k < mfit; k++)
      {
	//temp[j][k] = covar[j][k];
	//static_assert(0 <= j);
	//static_assert(j < temp_dim1);
	//static_assert(0 <= k);
	//static_assert(k < temp_dim2);
	//static_assert(0 <= j);
	//static_assert(j < covar_dim1);
	//static_assert(0 <= k);
	//static_assert(k < covar_dim2);
      }
  // gaussj(temp, beta);
  for (j = 0; j < mfit; j++)
    for (k = 0; k < mfit; k++)
      {
	//covar[j][k] = temp[j][k];
	//static_assert(0 <= j);
	//static_assert(j < covar_dim1);
	//static_assert(0 <= k);
	//static_assert(k < covar_dim2);
	//static_assert(0 <= j);
	//static_assert(j < temp_dim1);
	//static_assert(0 <= k);
	//static_assert(k < temp_dim2);
      }
  for (j = 0, l = 0; l < ma; l++) {
    //static_assert(0 <= l);
    //static_assert(l < ia_dim1);
    if (unknown() /*ia[l]*/)
      {
	//a[l] = beta[j++][0];
	//static_assert(0 <= l);
	//static_assert(l < a_dim1);
	static_assert(0 <= j++);
	//static_assert(j++ < beta_dim1);
	//static_assert(0 <= 0);
	//static_assert(0 < beta_dim2);
      }
  }
  // chisq = 0.0;
  for (i = 0; i < ndat; i++)
    {
      //funcs(x[i], afunc);
      //static_assert(0 <= i);
      //static_assert(i < x_dim1);
      // sum = 0.0;
      for (j = 0; j < ma; j++)
	{
	  //sum += a[j] * afunc[j];
	  //static_assert(0 <= j);
	  //static_assert(j < a_dim1);
	  //static_assert(0 <= j);
	  //static_assert(j < afunc_dim1);
	}
      //chisq += SQR((y[i] - sum) / sig[i]);
      //static_assert(0 <= i);
      //static_assert(i < y_dim1);
      //static_assert(0 <= i);
      //static_assert(i < sig_dim1);
    }
  // covsrt(covar, ia, mfit);
}
