// Numerical Recipes in C++, 2nd edition, pg. 49

#include <cmath>
int assume(bool);
int static_assert(bool);
int unknown();
using namespace std;

void
////NR::ludcmp(Mat_IO_DP & a, Vec_O_INT & indx, DP & d)
function()
{
  int a_dim1;
  assume(a_dim1 > 0);
  int a_dim2;
  assume(a_dim2 == a_dim1);
  int indx_dim1;
  assume(indx_dim1 == a_dim1);

  //const DP TINY = 1.0e-20;
  int i, imax, j, k;
  //DP big, dum, sum, temp;

  int n = a_dim1;
  //Vec_DP vv(n);
  int vv_dim1 = n;

  // d = 1.0;
  for (i = 0; i < n; i++)
    {
      // big = 0.0;
      for (j = 0; j < n; j++) {
	//static_assert(0 <= i);
	//static_assert(i < a_dim1);
	//static_assert(0 <= j);
	//static_assert(j < a_dim2);
	if (unknown() /*(temp = fabs(a[i][j])) > big*/)
	  {
	    // big = temp;
	  }
      }
      if (unknown() /*big == 0.0*/)
	{
	  // nrerror("Singular matrix in routine ludcmp");
	  return;
	}
      //vv[i] = 1.0 / big;
      static_assert(0 <= i);
      //static_assert(i < vv_dim1);
    }
  for (j = 0; j < n; j++)
    {
      for (i = 0; i < j; i++)
	{
	  //sum = a[i][j];
	  //static_assert(0 <= i);
	  //static_assert(i < a_dim1);
	  //static_assert(0 <= j);
	  //static_assert(j < a_dim2);
	  for (k = 0; k < i; k++)
	    {
	      //sum -= a[i][k] * a[k][j];
	      //static_assert(0 <= i);
	      //static_assert(i < a_dim1);
	      //static_assert(0 <= k);
	      //static_assert(k < a_dim2);
	      //static_assert(0 <= k);
	      //static_assert(k < a_dim1);
	      //static_assert(0 <= j);
	      //static_assert(j < a_dim2);
	    }
	  //a[i][j] = sum;
	  //static_assert(0 <= i);
	  //static_assert(i < a_dim1);
	  //static_assert(0 <= j);
	  //static_assert(j < a_dim2);
	}
      // big = 0.0;
      for (i = j; i < n; i++)
	{
	  //sum = a[i][j];
	  //static_assert(0 <= i);
	  //static_assert(i < a_dim1);
	  //static_assert(0 <= j);
	  //static_assert(j < a_dim2);
	  for (k = 0; k < j; k++)
	    {
	      //sum -= a[i][k] * a[k][j];
	      //static_assert(0 <= i);
	      //static_assert(i < a_dim1);
	      //static_assert(0 <= k);
	      //static_assert(k < a_dim2);
	      //static_assert(0 <= k);
	      //static_assert(k < a_dim1);
	      //static_assert(0 <= j);
	      //static_assert(j < a_dim2);
	    }
	  //a[i][j] = sum;
	  //static_assert(0 <= i);
	  //static_assert(i < a_dim1);
	  //static_assert(0 <= j);
	  //static_assert(j < a_dim2);

	  //static_assert(0 <= i);
	  //static_assert(i < vv_dim1);
	  if (unknown()/*(dum = vv[i] * fabs(sum)) >= big*/)
	  {
	    // big = dum;
	    imax = i;
	  }
	}
      if (j != imax)
	{
	  for (k = 0; k < n; k++)
	    {
	      //dum = a[imax][k];
	      //static_assert(0 <= imax);
	      //static_assert(imax < a_dim1);
	      //static_assert(0 <= k);
	      //static_assert(k < a_dim2);
	      //a[imax][k] = a[j][k];
	      //static_assert(0 <= imax);
	      //static_assert(imax < a_dim1);
	      //static_assert(0 <= k);
	      //static_assert(k < a_dim2);
	      //static_assert(0 <= j);
	      //static_assert(j < a_dim1);
	      //static_assert(0 <= k);
	      //static_assert(k < a_dim2);
	      //a[j][k] = dum;
	      //static_assert(0 <= j);
	      //static_assert(j < a_dim1);
	      //static_assert(0 <= k);
	      //static_assert(k < a_dim2);
	    }
	  // d = -d;
	  //vv[imax] = vv[j];
	  //static_assert(0 <= imax);
	  //static_assert(imax < vv_dim1);
	  //static_assert(0 <= j);
	  //static_assert(j < vv_dim1);
	}
      //indx[j] = imax;
      //static_assert(0 <= j);
      //static_assert(j < indx_dim1);

      //static_assert(0 <= j);
      //static_assert(j < a_dim1);
      //static_assert(0 <= j);
      //static_assert(j < a_dim2);
      if (unknown()/*a[j][j] == 0.0*/)
      {
	//a[j][j] = TINY;
	//static_assert(0 <= j);
	//static_assert(j < a_dim1);
	//static_assert(0 <= j);
	//static_assert(j < a_dim2);
      }
      if (j != n - 1)
	{
	  //dum = 1.0 / (a[j][j]);
	  //static_assert(0 <= j);
	  //static_assert(j < a_dim1);
	  //static_assert(0 <= j);
	  //static_assert(j < a_dim2);
	  for (i = j + 1; i < n; i++)
	    {
	      //a[i][j] *= dum;
	      //static_assert(0 <= i);
	      //static_assert(i < a_dim1);
	      //static_assert(0 <= j);
	      //static_assert(j < a_dim2);
	    }
	}
    }
}
