// Numerical Recipes in C++, 2nd edition, pg. 329

#include <cmath>
int assume(bool);
int static_assert(bool);
int unknown();
using namespace std;

void
////NR::miser(DP func(Vec_I_DP &), Vec_I_DP & regn, const int npts,
function()
//const DP dith, DP & ave, DP & var)
{
  // const int MNPT = 15, MNBS = 60;
  //const DP PFAC = 0.1, TINY = 1.0e-30, BIG = 1.0e30;
  // static int iran = 0;
  int j, jb, n, ndim, npre, nptl, nptr;
  //DP avel, varl, fracl, fval, rgl, rgm, rgr, s, sigl, siglb, sigr, sigrb;
  //DP sum, sumb, summ, summ2;

  assume(ndim > 0);
  int regn_dim1;
  assume(regn_dim1 == 2*ndim);

  //Vec_DP pt(ndim);
  int pt_dim1 = ndim;
  
  if (unknown() /*npts < MNBS*/)
    {
      // summ = summ2 = 0.0;
      // for (n = 0; n < npts; n++)
      // 	{
      // 	  ranpt(pt, regn);
      // 	  fval = func(pt);
      // 	  summ += fval;
      // 	  //summ2 += fval * fval;
      // 	}
      // ave = summ / npts;
      // //var = MAX(TINY, (summ2 - summ * summ / npts) / (npts * npts));
    }
  else
    {
      //Vec_DP rmid(ndim);
      //npre = MAX(int (npts * PFAC), int (MNPT));
      //Vec_DP fmaxl(ndim), fmaxr(ndim), fminl(ndim), fminr(ndim);
      int rmid_dim1 = ndim;
      int fmaxl_dim1 = ndim;
      int fmaxr_dim1 = ndim;
      int fminl_dim1 = ndim;
      int fminr_dim1 = ndim;
      for (j = 0; j < ndim; j++)
	{
	  //iran = (iran * 2661 + 36979) % 175000;
	  //s = SIGN(dith, DP(iran - 87500));
	  //rmid[j] = (0.5 + s) * regn[j] + (0.5 - s) * regn[ndim + j];
	  //static_assert(0 <= j);
	  //static_assert(j < rmid_dim1);
	  //static_assert(0 <= j);
	  //static_assert(j < regn_dim1);
	  //static_assert(0 <= ndim + j);
	  //static_assert(ndim + j < regn_dim1);
	  //fminl[j] = fminr[j] = BIG;
	  //static_assert(0 <= j);
	  //static_assert(j < fminl_dim1);
	  //static_assert(0 <= j);
	  //static_assert(j < fminr_dim1);
	  //fmaxl[j] = fmaxr[j] = (-BIG);
	  //static_assert(0 <= j);
	  //static_assert(j < fmaxl_dim1);
	  //static_assert(0 <= j);
	  //static_assert(j < fmaxr_dim1);
	}
      // for (n = 0; n < npre; n++)
      while (unknown())
	{
	  // ranpt(pt, regn);
	  // fval = func(pt);
	  for (j = 0; j < ndim; j++)
	    {
	      //static_assert(0 <= j);
	      //static_assert(j < pt_dim1);
	      //static_assert(0 <= j);
	      //static_assert(j < rmid_dim1);
	      if (unknown() /*pt[j] <= rmid[j]*/)
		{
		  //fminl[j] = MIN(fminl[j], fval);
		  //static_assert(0 <= j);
		  //static_assert(j < fminl_dim1);
		  //static_assert(0 <= j);
		  //static_assert(j < fminl_dim1);
		  //fmaxl[j] = MAX(fmaxl[j], fval);
		  //static_assert(0 <= j);
		  //static_assert(j < fmaxl_dim1);
		  //static_assert(0 <= j);
		  //static_assert(j < fmaxl_dim1);
		}
	      else
		{
		  //fminr[j] = MIN(fminr[j], fval);
		  //static_assert(0 <= j);
		  //static_assert(j < fminr_dim1);
		  //static_assert(0 <= j);
		  //static_assert(j < fminr_dim1);
		  //fmaxr[j] = MAX(fmaxr[j], fval);
		  //static_assert(0 <= j);
		  //static_assert(j < fmaxr_dim1);
		  //static_assert(0 <= j);
		  //static_assert(j < fmaxr_dim1);
		}
	    }
	}
      // sumb = BIG;
      jb = -1;
      // siglb = sigrb = 1.0;
      for (j = 0; j < ndim; j++)
	{
	  //static_assert(0 <= j);
	  //static_assert(j < fmaxl_dim1);
	  //static_assert(0 <= j);
	  //static_assert(j < fminl_dim1);
	  //static_assert(0 <= j);
	  //static_assert(j < fmaxr_dim1);
	  //static_assert(0 <= j);
	  //static_assert(j < fminr_dim1);
	  if (unknown() /*fmaxl[j] > fminl[j] && fmaxr[j] > fminr[j]*/)
	    {
	      //sigl = MAX(TINY, pow(fmaxl[j] - fminl[j], 2.0 / 3.0));
	      //static_assert(0 <= j);
	      //static_assert(j < fmaxl_dim1);
	      //static_assert(0 <= j);
	      //static_assert(j < fminl_dim1);
	      //sigr = MAX(TINY, pow(fmaxr[j] - fminr[j], 2.0 / 3.0));
	      static_assert(0 <= j);
	      //static_assert(j < fmaxr_dim1);
	      //static_assert(0 <= j);
	      //static_assert(j < fminr_dim1);
	      // sum = sigl + sigr;
	      if (unknown() /*sum <= sumb*/)
		{
		  // sumb = sum;
		  jb = j;
		  // siglb = sigl;
		  // sigrb = sigr;
		}
	    }
	}
      if (jb == -1)
	{
	  jb = unknown(); /*(ndim * iran) / 175000;*/
	  assume(jb >= 0);
	  assume(jb < ndim);
	}
      //rgl = regn[jb];
      //static_assert(0 <= jb);
      //static_assert(jb < regn_dim1);
      //rgm = rmid[jb];
      //static_assert(0 <= jb);
      //static_assert(jb < rmid_dim1);
      //rgr = regn[ndim + jb];
      //static_assert(0 <= ndim + jb);
      //static_assert(ndim + jb < regn_dim1);
      // fracl = fabs((rgm - rgl) / (rgr - rgl));
      //nptl = int (MNPT + (npts - npre - 2 * MNPT) * fracl * siglb
      /// (fracl * siglb + (1.0 - fracl) * sigrb));
      // nptr = npts - npre - nptl;

      //Vec_DP regn_temp(2 * ndim);
      int regn_temp_dim1 = 2*ndim;
      
      for (j = 0; j < ndim; j++)
	{
	  //regn_temp[j] = regn[j];
	  //static_assert(0 <= j);
	  //static_assert(j < regn_temp_dim1);
	  //static_assert(0 <= j);
	  //static_assert(j < regn_dim1);
	  //regn_temp[ndim + j] = regn[ndim + j];
	  //static_assert(0 <= ndim + j);
	  //static_assert(ndim + j < regn_temp_dim1);
	  //static_assert(0 <= ndim + j);
	  //static_assert(ndim + j < regn_dim1);
	}
      //regn_temp[ndim + jb] = rmid[jb];
      //static_assert(0 <= ndim + jb);
      //static_assert(ndim + jb < regn_temp_dim1);
      //static_assert(0 <= jb);
      //static_assert(jb < rmid_dim1);
      // miser(func, regn_temp, nptl, dith, avel, varl);
      //regn_temp[jb] = rmid[jb];
      //static_assert(0 <= jb);
      //static_assert(jb < regn_temp_dim1);
      //static_assert(0 <= jb);
      //static_assert(jb < rmid_dim1);
      //regn_temp[ndim + jb] = regn[ndim + jb];
      //static_assert(0 <= ndim + jb);
      //static_assert(ndim + jb < regn_temp_dim1);
      //static_assert(0 <= ndim + jb);
      //static_assert(ndim + jb < regn_dim1);
      // miser(func, regn_temp, nptr, dith, ave, var);
      //ave = fracl * avel + (1 - fracl) * ave;
      //var = fracl * fracl * varl + (1 - fracl) * (1 - fracl) * var;
    }
}
