// Numerical Recipes in C++, 2nd edition, pg. 923

#include <cmath>
int assume(bool);
int static_assert(bool);
int unknown();
using namespace std;

void
//NR::mpsqrt(Vec_O_UCHR & w, Vec_O_UCHR & u, Vec_I_UCHR & v)
function()
{
  int u_dim1;
  assume(u_dim1 > 0);
  int v_dim1;
  assume(v_dim1 > 0);

  const int MF = 3;
  //const DP BI = 1.0 / 256.0;
  int i, ir, j, mm;
  //DP fu, fv;

  int n = u_dim1;
  int m = v_dim1;
  //Vec_UCHR r(2 * n), x(n + m), s(2 * n + m), t(3 * n + m);
  int s_dim1; // = 2*n + m;
  assume(s_dim1 >= n);

  // mm = MIN(m, MF);
  if (m < MF) mm = m;
  else        mm = MF;

  //fv = DP(v[mm - 1]);
  //static_assert(0 <= mm - 1);
  //static_assert(mm - 1 < v_dim1);
  for (j = mm - 2; j >= 0; j--)
    {
      // fv *= BI;
      //fv += v[j];
      //static_assert(0 <= j);
      //static_assert(j < v_dim1);
    }
  // fu = 1.0 / sqrt(fv);
  for (j = 0; j < n; j++)
    {
      // i = int (fu);
      //u[j] = (unsigned char) i;
      //static_assert(0 <= j);
      //static_assert(j < u_dim1);
      //fu = 256.0 * (fu - i);
    }
  for (;;)
    {
      // mpmul(r, u, u);
      // mplsh(r);
      // mpmul(s, r, v);
      // mplsh(s);
      // mpneg(s);
      //s[0] += (unsigned char) 3;
      //static_assert(0 <= 0);
      static_assert(0 < s_dim1);
      // mpsdv(s, s, 2, ir);
      for (j = 1; j < n - 1; j++)
	{
	  //static_assert(0 <= j);
	  //static_assert(j < s_dim1);
	  if (unknown() /*s[j] != 0*/)
	  {
	    // mpmul(t, s, u);
	    // mplsh(t);
	    // mpmov(u, t);
	    break;
	  }
	}
      if (j < n - 1)
	{
	  continue;
	}
      // mpmul(x, u, v);
      // mplsh(x);
      // mpmov(w, x);
      return;
    }
}
