// Numerical Recipes in C++, 2nd edition, pg. 726

#include <cmath>
int assume(bool);
int static_assert(bool);
int unknown();
using namespace std;

//extern DP dxsav;
// extern int kmax, kount;
//extern Vec_DP *xp_p;
//extern Mat_DP *yp_p;

void
////NR::odeint(Vec_IO_DP & ystart, const DP x1, const DP x2, const DP eps,
function(int kmax, int kount, int nok, int nbad)
//const DP h1, const DP hmin, int &nok, int &nbad,
//void derivs(const DP, Vec_I_DP &, Vec_O_DP &),
//void rkqs(Vec_IO_DP &, Vec_IO_DP &, DP &, const DP, const DP,
//Vec_I_DP &, DP &, DP &, void (*)(const DP, Vec_I_DP &,
//Vec_O_DP &)))
{
  assume(kmax > 0);
  
  int ystart_dim1;
  assume(ystart_dim1 > 0);

  int xp_dim1;
  assume(xp_dim1 == kmax);
  int yp_dim1;
  assume(yp_dim1 == ystart_dim1);
  int yp_dim2;
  assume(yp_dim2 == kmax);

  const int MAXSTP = 10000;
  //const DP TINY = 1.0e-30;
  int i, nstp;
  //DP xsav, x, hnext, hdid, h;

  int nvar = ystart_dim1;
  //Vec_DP yscal(nvar), y(nvar), dydx(nvar);
  int yscal_dim1 = nvar;
  int y_dim1 = nvar;
  int dydx_dim1 = nvar;

  //Vec_DP & xp = *xp_p;
  //Mat_DP & yp = *yp_p;
  // x = x1;
  // h = SIGN(h1, x2 - x1);
  nok = 0;
  nbad = 0;
  kount = 0;
  for (i = 0; i < nvar; i++)
    {
      //y[i] = ystart[i];
      //static_assert(0 <= i);
      //static_assert(i < y_dim1);
      //static_assert(0 <= i);
      //static_assert(i < ystart_dim1);
    }
  if (kmax > 0)
    {
      //xsav = x - dxsav * 2.0;
    }

  for (nstp = 0; nstp < MAXSTP; nstp++)
    {
      // derivs(x, y, dydx);
      for (i = 0; i < nvar; i++)
	{
	  //yscal[i] = fabs(y[i]) + fabs(dydx[i] * h) + TINY;
	  //static_assert(0 <= i);
	  //static_assert(i < yscal_dim1);
	  static_assert(0 <= i);
	  //static_assert(i < y_dim1);
	  //static_assert(0 <= i);
	  //static_assert(i < dydx_dim1);
	}

      if (unknown())
	// if (kmax > 0 && kount < kmax - 1 && fabs(x - xsav) > fabs(dxsav))	
	{
	  assume(kmax > 0);
	  assume(kount < kmax - 1);	  

	  for (i = 0; i < nvar; i++)
	    {
	      ////yp[i][kount] = y[i];
	      //static_assert(0 <= i);
	      //static_assert(i < yp_dim1);
	      //static_assert(0 <= kount);
	      //static_assert(kount < yp_dim2);
	      //static_assert(0 <= i);
	      //static_assert(i < y_dim1);
	    }
	  //xp[kount] = x;

	  //static_assert(0 <= kount);
	  //static_assert(kount < xp_dim1);
	  kount++;
	  // xsav = x;
	}
      //if ((x + h - x2) * (x + h - x1) > 0.0)
      // {
      // 	h = x2 - x;
      // }
      // rkqs(y, dydx, x, h, eps, yscal, hdid, hnext, derivs);

      if (unknown())
	// if (hdid == h)
	{
	  ++nok;
	}
      else
	{
	  ++nbad;
	}

      if (unknown())
	// if ((x - x2) * (x2 - x1) >= 0.0)  
	{
	  for (i = 0; i < nvar; i++)
	    {
	      //ystart[i] = y[i];
	      //static_assert(0 <= i);
	      //static_assert(i < ystart_dim1);
	      //static_assert(0 <= i);
	      //static_assert(i < y_dim1);
	    }
	  if (kmax != 0)
	    {
	      for (i = 0; i < nvar; i++)
		{
		  ////yp[i][kount] = y[i];
		  //static_assert(0 <= i);
		  //static_assert(i < yp_dim1);
		  //static_assert(0 <= kount);
		  //static_assert(kount < yp_dim2);
		  //static_assert(0 <= i);
		  //static_assert(i < y_dim1);
		}
	      //xp[kount] = x;
	      //static_assert(0 <= kount);
	      //static_assert(kount < xp_dim1);
	      kount++;
	    }
	  return;
	}
      if (unknown())
	// if (fabs(hnext) <= hmin)  
	{
	  // nrerror("Step size too small in odeint");
	  return;
	}
      // h = hnext;
    }
  // nrerror("Too many steps in routine odeint");

}

