// Numerical Recipes in C++, 2nd edition, pg. 181

int assume(bool);
int static_assert(bool);
int unknown();

void
////NR::poldiv(Vec_I_DP & u, Vec_I_DP & v, Vec_O_DP & q, Vec_O_DP & r)
function()
{

  int q_dim1;
  int r_dim1;
  int u_dim1;
  int v_dim1;

  int k, j;

  int n = u_dim1 - 1;
  int nv = v_dim1 - 1;

  assume(n  >= 0);
  assume(nv >= 0);  
  assume(q_dim1 == n+1);
  assume(r_dim1 == n+1);
  assume(u_dim1 == n+1);

  for (j = 0; j <= n; j++)
    {
      //r[j] = u[j];
      //static_assert(0 <= j);
      //static_assert(j < r_dim1);
      //static_assert(0 <= j);
      //static_assert(j < u_dim1);
      //q[j] = 0.0;
      //static_assert(0 <= j);
      //static_assert(j < q_dim1);
    }
  for (k = n - nv; k >= 0; k--)
    {
      //q[k] = r[nv + k] / v[nv];
      //static_assert(0 <= k);
      //static_assert(k < q_dim1);
      //static_assert(0 <= nv + k);
      //static_assert(nv + k < r_dim1);
      //static_assert(0 <= nv);
      //static_assert(nv < v_dim1);
      for (j = nv + k - 1; j >= k; j--)
	{
	  //r[j] -= q[k] * v[j - k];
	  //static_assert(0 <= j);
	  static_assert(j < r_dim1);
	  //static_assert(0 <= k);
	  //static_assert(k < q_dim1);
	  //static_assert(0 <= j - k);
	  //static_assert(j - k < v_dim1);
	}
    }
  for (j = nv; j <= n; j++)
    {
      //r[j] = 0.0;
      //static_assert(0 <= j);
      //static_assert(j < r_dim1);
    }
}
