// Numerical Recipes in C++, 2nd edition, pg. 422

#include <cmath>
int assume(bool);
int static_assert(bool);
int unknown();
using namespace std;

void
////NR::powell(Vec_IO_DP & p, Mat_IO_DP & xi, const DP ftol, int &iter,
function(int iter)
//DP & fret, DP
//func(Vec_I_DP &))
{
  int p_dim1;
  assume(p_dim1 > 0);
  int xi_dim1;
  assume(xi_dim1 == p_dim1);
  int xi_dim2;
  assume(xi_dim2 == p_dim1);

  const int ITMAX = 200;
  //const DP TINY = 1.0e-25;
  int i, j, ibig;
  //DP del, fp, fptt, t;

  int n = p_dim1;
  //Vec_DP pt(n), ptt(n), xit(n);
  int pt_dim1 = n;
  int ptt_dim1 = n;
  int xit_dim1 = n;

  // fret = func(p);
  for (j = 0; j < n; j++)
    {
      ////pt[j] = p[j];
      //static_assert(0 <= j);
      //static_assert(j < pt_dim1);
      //static_assert(0 <= j);
      //static_assert(j < p_dim1);
    }
  for (iter = 0;; ++iter)
    {
      // fp = fret;
      ibig = 0;
      // del = 0.0;
      for (i = 0; i < n; i++)
	{
	  for (j = 0; j < n; j++)
	    {
	      //xit[j] = xi[j][i];
	      //static_assert(0 <= j);
	      //static_assert(j < xit_dim1);
	      //static_assert(0 <= j);
	      //static_assert(j < xi_dim1);
	      //static_assert(0 <= i);
	      //static_assert(i < xi_dim2);
	    }
	  // fptt = fret;
	  // linmin(p, xit, fret, func);
	  if (unknown() /*fptt - fret > del*/)
	    {
	      // del = fptt - fret;
	      ibig = i + 1;
	    }
	}
      if (unknown()/*2.0 * (fp - fret) <= ftol * (fabs(fp) + fabs(fret)) + TINY*/)
        {
	  return;
        }
      if (iter == ITMAX)
	{
	  // nrerror("powell exceeding maximum iterations.");
	  return;
	}
      for (j = 0; j < n; j++)
	{
	  //ptt[j] = 2.0 * p[j] - pt[j];
	  //static_assert(0 <= j);
	  //static_assert(j < ptt_dim1);
	  //static_assert(0 <= j);
	  //static_assert(j < p_dim1);
	  //static_assert(0 <= j);
	  static_assert(j < pt_dim1);
	  //xit[j] = p[j] - pt[j];
	  //static_assert(0 <= j);
	  //static_assert(j < xit_dim1);
	  //static_assert(0 <= j);
	  //static_assert(j < p_dim1);
	  //static_assert(0 <= j);
	  //static_assert(j < pt_dim1);
	  ////pt[j] = p[j];
	  //static_assert(0 <= j);
	  //static_assert(j < pt_dim1);
	  //static_assert(0 <= j);
	  //static_assert(j < p_dim1);
	}
      // fptt = func(ptt);
      if (unknown() /*fptt < fp*/)
	{
	  // t =
	    //2.0 * (fp - 2.0 * fret + fptt) * SQR(fp - fret - del) -
	    //del * SQR(fp - fptt);
	  if (unknown() /*t < 0.0*/)
	    {
	      // linmin(p, xit, fret, func);
	      for (j = 0; j < n; j++)
		{
		  //xi[j][ibig - 1] = xi[j][n - 1];
		  //static_assert(0 <= j);
		  //static_assert(j < xi_dim1);
		  //static_assert(0 <= ibig - 1);
		  //static_assert(ibig - 1 < xi_dim2);
		  //static_assert(0 <= j);
		  //static_assert(j < xi_dim1);
		  //static_assert(0 <= n - 1);
		  //static_assert(n - 1 < xi_dim2);
		  //xi[j][n - 1] = xit[j];
		  //static_assert(0 <= j);
		  //static_assert(j < xi_dim1);
		  //static_assert(0 <= n - 1);
		  //static_assert(n - 1 < xi_dim2);
		  //static_assert(0 <= j);
		  //static_assert(j < xit_dim1);
		}
	    }
	}
    }
}
