// Numerical Recipes in C++, 2nd edition, pg. 881

int assume(bool);
int static_assert(bool);
int unknown();

void
////NR::rstrct(Mat_O_DP & uc, Mat_I_DP & uf)
function()
{

  int nc, nc2;
  assume(nc  >= 1);
  assume(nc2 >= 2);

  int uc_dim1;  assume(uc_dim1 == nc);
  int uc_dim2;  assume(uc_dim2 == nc);
  int uf_dim1;  assume(uf_dim1 == nc2 - 1);
  int uf_dim2;  assume(uf_dim2 == nc2 - 1);

  int ic, iif, jc, jf, ncc;
  int ic2; // stands for 2*ic
  int jc2; // stands for 2*jc
  //ncc = 2 * nc - 2;
  ncc = nc2 - 2;

  for (jf = 2, jc = 1, jc2 = 2; jc <= nc - 2; jc++, jf += 2, jc2 += 2)
    {
      assume(jc2 <= nc2 - 4);
      for (iif = 2, ic = 1, ic2 = 2; ic <= nc - 2; ic++, iif += 2, ic2 += 2)
	{
	  assume(ic2 <= nc2 - 4);
	  //uc[ic][jc] =
	  //static_assert(0 <= ic);
	  //static_assert(ic < uc_dim1);
	  //static_assert(0 <= jc);
	  //static_assert(jc < uc_dim2);
	  //0.5 *uf[iif][jf] + 0.125 * (uf[iif + 1][jf] + uf[iif - 1][jf] +
	  //static_assert(0 <= iif);
	  //static_assert(iif < uf_dim1);
	  //static_assert(0 <= jf);
	  //static_assert(jf < uf_dim2);
	  //static_assert(0 <= iif + 1);
	  //static_assert(iif + 1 < uf_dim1);
	  //static_assert(0 <= jf);
	  static_assert(jf < uf_dim2);
	  //static_assert(0 <= iif - 1);
	  //static_assert(iif - 1 < uf_dim1);
	  //static_assert(0 <= jf);
	  //static_assert(jf < uf_dim2);
	  //uf[iif][jf + 1] + uf[iif][jf - 1]);
	  //static_assert(0 <= iif);
	  //static_assert(iif < uf_dim1);
	  //static_assert(0 <= jf + 1);
	  //static_assert(jf + 1 < uf_dim2);
	  //static_assert(0 <= iif);
	  //static_assert(iif < uf_dim1);
	  //static_assert(0 <= jf - 1);
	  //static_assert(jf - 1 < uf_dim2);
	}
    }
  for (jc = 0, ic = 0, jc2 = 0, ic2 = 0; ic <= nc - 1; ic++, jc += 2, ic += 2, jc2 += 4)
    {
      assume(ic2 <= nc2 - 2);
      //uc[ic][0] = uf[jc][0];
      //static_assert(0 <= ic);
      //static_assert(ic < uc_dim1);
      //static_assert(0 <= 0);
      //static_assert(0 < uc_dim2);
      //static_assert(0 <= jc);
      //static_assert(jc < uf_dim1);
      //static_assert(0 <= 0);
      //static_assert(0 < uf_dim2);
      //uc[ic][nc - 1] = uf[jc][ncc];
      //static_assert(0 <= ic);
      //static_assert(ic < uc_dim1);
      //static_assert(0 <= nc - 1);
      //static_assert(nc - 1 < uc_dim2);
      //static_assert(0 <= jc);
      //static_assert(jc < uf_dim1);
      //static_assert(0 <= ncc);
      //static_assert(ncc < uf_dim2);
    }
  for (jc = 0, ic = 0, jc2 = 0, ic2 = 0; ic <= nc - 1; ic++, jc += 2, ic += 2, jc2 += 4)
    {
      assume(ic2 <= nc2 - 2);
      //uc[0][ic] = uf[0][jc];
      //static_assert(0 <= 0);
      //static_assert(0 < uc_dim1);
      //static_assert(0 <= ic);
      //static_assert(ic < uc_dim2);
      //static_assert(0 <= 0);
      //static_assert(0 < uf_dim1);
      //static_assert(0 <= jc);
      //static_assert(jc < uf_dim2);
      //uc[nc - 1][ic] = uf[ncc][jc];
      //static_assert(0 <= nc - 1);
      //static_assert(nc - 1 < uc_dim1);
      //static_assert(0 <= ic);
      //static_assert(ic < uc_dim2);
      //static_assert(0 <= ncc);
      //static_assert(ncc < uf_dim1);
      //static_assert(0 <= jc);
      //static_assert(jc < uf_dim2);
    }
}
