// Numerical Recipes in C++, 2nd edition, pg. 747

int assume(bool);
int static_assert(bool);
int unknown();

void
////NR::simpr(Vec_I_DP & y, Vec_I_DP & dydx, Vec_I_DP & dfdx, Mat_I_DP & dfdy,
function(int nstep)
     //const DP xs, const DP htot, const int nstep, Vec_O_DP & yout,
       //void derivs(const DP, Vec_I_DP &, Vec_O_DP &))
{

  int y_dim1;
  assume(y_dim1 > 0);
  int dfdx_dim1;
  assume(dfdx_dim1 == y_dim1);
  int dfdy_dim1;
  assume(dfdy_dim1 == y_dim1);
  int dfdy_dim2;
  assume(dfdy_dim2 == y_dim1);
  int dydx_dim1;
  assume(dydx_dim1 == y_dim1);
  int yout_dim1;
  assume(yout_dim1 == y_dim1);

  int i, j, nn;
  //DP d, h, x;

  int n = y_dim1;
  //Mat_DP a(n, n);
  //Vec_INT indx(n);
  //Vec_DP del(n), ytemp(n);
  int a_dim1 = n;
  int a_dim2 = n;
  int del_dim1 = n;
  int ytemp_dim1 = n;

  // h = htot / nstep;
  for (i = 0; i < n; i++)
    {
      for (j = 0; j < n; j++)
	{
	  //a[i][j] = -h * dfdy[i][j];
	  static_assert(0 <= i);
	  //static_assert(i < a_dim1);
	  //static_assert(0 <= j);
	  //static_assert(j < a_dim2);
	  //static_assert(0 <= i);
	  //static_assert(i < dfdy_dim1);
	  //static_assert(0 <= j);
	  //static_assert(j < dfdy_dim2);
	}
      //++a[i][i];
      //static_assert(0 <= i);
      //static_assert(i < a_dim1);
      //static_assert(0 <= i);
      //static_assert(i < a_dim2);
    }
  // ludcmp(a, indx, d);
  for (i = 0; i < n; i++)
    {
      //yout[i] = h * (dydx[i] + h * dfdx[i]);
      //static_assert(0 <= i);
      //static_assert(i < yout_dim1);
      //static_assert(0 <= i);
      //static_assert(i < dydx_dim1);
      //static_assert(0 <= i);
      //static_assert(i < dfdx_dim1);
    }
  // lubksb(a, indx, yout);
  for (i = 0; i < n; i++)
    {
      //ytemp[i] = y[i] + (del[i] = yout[i]);
      //static_assert(0 <= i);
      //static_assert(i < ytemp_dim1);
      //static_assert(0 <= i);
      //static_assert(i < y_dim1);
      //static_assert(0 <= i);
      //static_assert(i < del_dim1);
      //static_assert(0 <= i);
      //static_assert(i < yout_dim1);
    }
  // x = xs + h;
  // derivs(x, ytemp, yout);
  for (nn = 2; nn <= nstep; nn++)
    {
      for (i = 0; i < n; i++)
	{
	  ////yout[i] = h * yout[i] - del[i];
	  //static_assert(0 <= i);
	  //static_assert(i < yout_dim1);
	  //static_assert(0 <= i);
	  //static_assert(i < yout_dim1);
	  //static_assert(0 <= i);
	  //static_assert(i < del_dim1);
	}
      // lubksb(a, indx, yout);
      for (i = 0; i < n; i++)
	{
	  //ytemp[i] += (del[i] += 2.0 * yout[i]);
	  //static_assert(0 <= i);
	  //static_assert(i < ytemp_dim1);
	  //static_assert(0 <= i);
	  //static_assert(i < del_dim1);
	  //static_assert(0 <= i);
	  //static_assert(i < yout_dim1);
	}
      // x += h;
      // derivs(x, ytemp, yout);
    }
  for (i = 0; i < n; i++)
    {
      ////yout[i] = h * yout[i] - del[i];
      //static_assert(0 <= i);
      //static_assert(i < yout_dim1);
      //static_assert(0 <= i);
      //static_assert(i < yout_dim1);
      //static_assert(0 <= i);
      //static_assert(i < del_dim1);
    }
  // lubksb(a, indx, yout);
  for (i = 0; i < n; i++)
    {
      //yout[i] += ytemp[i];
      //static_assert(0 <= i);
      //static_assert(i < yout_dim1);
      //static_assert(0 <= i);
      //static_assert(i < ytemp_dim1);
    }
}
