// Numerical Recipes in C++, 2nd edition, pg. 98

int assume(bool);
int static_assert(bool);
int unknown();

void
////NR::toeplz(Vec_I_DP & r, Vec_O_DP & x, Vec_I_DP & y)
function()
{
  int x_dim1;
  assume(x_dim1 > 0);
  int y_dim1;
  assume(y_dim1 == x_dim1);
  int r_dim1;
  assume(r_dim1 == 2*x_dim1 - 1);

  int j, k, m, m1, m2, n, n1;
  //DP pp, pt1, pt2, qq, qt1, qt2, sd, sgd, sgn, shn, sxn;

  n = y_dim1;
  n1 = n - 1;
  //static_assert(0 <= n1);
  //static_assert(n1 < r_dim1);
  // if (unknown() /*r[n1] == 0.0*/)
  // {
  //   // nrerror("toeplz-1 singular principal minor");
  //   return;
  // }
  //x[0] = y[0] / r[n1];
  //static_assert(0 <= 0);
  //static_assert(0 < x_dim1);
  //static_assert(0 <= 0);
  //static_assert(0 < y_dim1);
  //static_assert(0 <= n1);
  //static_assert(n1 < r_dim1);
  if (n1 == 0)
    {
      return;
    }
  //Vec_DP g(n1), h(n1);
  int g_dim1 = n1;
  int h_dim1 = n1;

  //g[0] = r[n1 - 1] / r[n1];
  //static_assert(0 <= 0);
  //static_assert(0 < g_dim1);
  //static_assert(0 <= n1 - 1);
  //static_assert(n1 - 1 < r_dim1);
  //static_assert(0 <= n1);
  //static_assert(n1 < r_dim1);
  //h[0] = r[n1 + 1] / r[n1];
  //static_assert(0 <= 0);
  //static_assert(0 < h_dim1);
  //static_assert(0 <= n1 + 1);
  //static_assert(n1 + 1 < r_dim1);
  //static_assert(0 <= n1);
  //static_assert(n1 < r_dim1);
  for (m = 0; m < n; m++)
    {
      m1 = m + 1;
      //sxn = -y[m1];
      //static_assert(0 <= m1);
      //static_assert(m1 < y_dim1);
      //sd = -r[n1];
      //static_assert(0 <= n1);
      //static_assert(n1 < r_dim1);
      for (j = 0; j < m + 1; j++)
	{
	  //sxn += r[n1 + m1 - j] * x[j];
	  //static_assert(0 <= n1 + m1 - j);
	  //static_assert(n1 + m1 - j < r_dim1);
	  //static_assert(0 <= j);
	  //static_assert(j < x_dim1);
	  //sd += r[n1 + m1 - j] * g[m - j];
	  //static_assert(0 <= n1 + m1 - j);
	  //static_assert(n1 + m1 - j < r_dim1);
	  //static_assert(0 <= m - j);
	  //static_assert(m - j < g_dim1);
	}
      // if (sd == 0.0)
      // 	{
      // 	  nrerror("toeplz-2 singular principal minor");
      // 	}
      //x[m1] = sxn / sd;
      //static_assert(0 <= m1);
      //static_assert(m1 < x_dim1);
      for (j = 0; j < m + 1; j++)
	{
	  //x[j] -= x[m1] * g[m - j];
	  static_assert(0 <= j);
	  //static_assert(j < x_dim1);
	  //static_assert(0 <= m1);
	  //static_assert(m1 < x_dim1);
	  //static_assert(0 <= m - j);
	  //static_assert(m - j < g_dim1);
	}
      if (m1 == n1)
	{
	  return;
	}
      //sgn = -r[n1 - m1 - 1];
      //static_assert(0 <= n1 - m1 - 1);
      //static_assert(n1 - m1 - 1 < r_dim1);
      //shn = -r[n1 + m1 + 1];
      //static_assert(0 <= n1 + m1 + 1);
      //static_assert(n1 + m1 + 1 < r_dim1);
      //sgd = -r[n1];
      //static_assert(0 <= n1);
      //static_assert(n1 < r_dim1);
      for (j = 0; j < m + 1; j++)
	{
	  //sgn += r[n1 + j - m1] * g[j];
	  //static_assert(0 <= n1 + j - m1);
	  //static_assert(n1 + j - m1 < r_dim1);
	  //static_assert(0 <= j);
	  //static_assert(j < g_dim1);
	  //shn += r[n1 + m1 - j] * h[j];
	  //static_assert(0 <= n1 + m1 - j);
	  //static_assert(n1 + m1 - j < r_dim1);
	  //static_assert(0 <= j);
	  //static_assert(j < h_dim1);
	  //sgd += r[n1 + j - m1] * h[m - j];
	  //static_assert(0 <= n1 + j - m1);
	  //static_assert(n1 + j - m1 < r_dim1);
	  //static_assert(0 <= m - j);
	  //static_assert(m - j < h_dim1);
	}
      // if (sgd == 0.0)
      // 	{
      // 	  nrerror("toeplz-3 singular principal minor");
      // 	}
      //g[m1] = sgn / sgd;
      //static_assert(0 <= m1);
      //static_assert(m1 < g_dim1);
      //h[m1] = shn / sd;
      //static_assert(0 <= m1);
      //static_assert(m1 < h_dim1);
      k = m;
      m2 = (m + 2) / 2;
      //pp = g[m1];
      //static_assert(0 <= m1);
      //static_assert(m1 < g_dim1);
      //qq = h[m1];
      //static_assert(0 <= m1);
      //static_assert(m1 < h_dim1);
      for (j = 0; j < m2; j++)
	{
	  //pt1 = g[j];
	  //static_assert(0 <= j);
	  //static_assert(j < g_dim1);
	  //pt2 = g[k];
	  //static_assert(0 <= k);
	  //static_assert(k < g_dim1);
	  //qt1 = h[j];
	  //static_assert(0 <= j);
	  //static_assert(j < h_dim1);
	  //qt2 = h[k];
	  //static_assert(0 <= k);
	  //static_assert(k < h_dim1);
	  //g[j] = pt1 - pp * qt2;
	  //static_assert(0 <= j);
	  //static_assert(j < g_dim1);
	  //g[k] = pt2 - pp * qt1;
	  //static_assert(0 <= k);
	  //static_assert(k < g_dim1);
	  //h[j] = qt1 - qq * pt2;
	  //static_assert(0 <= j);
	  //static_assert(j < h_dim1);
	  //h[k] = qt2 - qq * pt1;
	  //static_assert(0 <= k);
	  //static_assert(k < h_dim1);
	  k--;
	}
    }
  // nrerror("toeplz - should not arrive here!");
}
