// Numerical Recipes in C++, 2nd edition, pg. 516

int assume(bool);
int static_assert(bool);
int unknown();

void
////NR::twofft(Vec_I_DP & data1, Vec_I_DP & data2, Vec_O_DP & fft1,
function()
//Vec_O_DP & fft2)
{

  int data1_dim1;
  assume(data1_dim1 > 0);
  int data2_dim1;
  assume(data2_dim1 == data1_dim1);
  int fft1_dim1;
  assume(fft1_dim1 == 2*data1_dim1);
  int fft2_dim1;
  assume(fft2_dim1 == 2*data1_dim1);

  int nn3, nn2, jj, j;
  //DP rep, rem, aip, aim;

  int n = data1_dim1;
  nn2 = n + n;
  nn3 = 1 + nn2;
  for (j = 0, jj = 0; j < n; j++, jj += 2)
    {
      //fft1[jj] = data1[j];
      //static_assert(0 <= jj);
      //static_assert(jj < fft1_dim1);
      //static_assert(0 <= j);
      //static_assert(j < data1_dim1);
      //fft1[jj + 1] = data2[j];
      //static_assert(0 <= jj + 1);
      //static_assert(jj + 1 < fft1_dim1);
      //static_assert(0 <= j);
      //static_assert(j < data2_dim1);
    }
  // four1(fft1, 1);
  //fft2[0] = fft1[1];
  //static_assert(0 <= 0);
  //static_assert(0 < fft2_dim1);
  //static_assert(0 <= 1);
  //static_assert(1 < fft1_dim1);
  //fft1[1] = fft2[1] = 0.0;
  //static_assert(0 <= 1);
  //static_assert(1 < fft1_dim1);
  //static_assert(0 <= 1);
  //static_assert(1 < fft2_dim1);
  for (j = 2; j < n + 1; j += 2)
    {
      //rep = 0.5 * (fft1[j] + fft1[nn2 - j]);
      //static_assert(0 <= j);
      //static_assert(j < fft1_dim1);
      //static_assert(0 <= nn2 - j);
      //static_assert(nn2 - j < fft1_dim1);
      //rem = 0.5 * (fft1[j] - fft1[nn2 - j]);
      //static_assert(0 <= j);
      //static_assert(j < fft1_dim1);
      //static_assert(0 <= nn2 - j);
      //static_assert(nn2 - j < fft1_dim1);
      //aip = 0.5 * (fft1[j + 1] + fft1[nn3 - j]);
      //static_assert(0 <= j + 1);
      //static_assert(j + 1 < fft1_dim1);
      //static_assert(0 <= nn3 - j);
      //static_assert(nn3 - j < fft1_dim1);
      //aim = 0.5 * (fft1[j + 1] - fft1[nn3 - j]);
      //static_assert(0 <= j + 1);
      //static_assert(j + 1 < fft1_dim1);
      //static_assert(0 <= nn3 - j);
      //static_assert(nn3 - j < fft1_dim1);
      //fft1[j] = rep;
      //static_assert(0 <= j);
      static_assert(j < fft1_dim1);
      //fft1[j + 1] = aim;
      //static_assert(0 <= j + 1);
      //static_assert(j + 1 < fft1_dim1);
      //fft1[nn2 - j] = rep;
      //static_assert(0 <= nn2 - j);
      //static_assert(nn2 - j < fft1_dim1);
      //fft1[nn3 - j] = -aim;
      //static_assert(0 <= nn3 - j);
      //static_assert(nn3 - j < fft1_dim1);
      //fft2[j] = aip;
      //static_assert(0 <= j);
      //static_assert(j < fft2_dim1);
      //fft2[j + 1] = -rem;
      //static_assert(0 <= j + 1);
      //static_assert(j + 1 < fft2_dim1);
      //fft2[nn2 - j] = aip;
      //static_assert(0 <= nn2 - j);
      //static_assert(nn2 - j < fft2_dim1);
      //fft2[nn3 - j] = rem;
      //static_assert(0 <= nn3 - j);
      //static_assert(nn3 - j < fft2_dim1);
    }
}
