// Numerical Recipes in C++, 2nd edition, pg. 379

#include <complex>
int assume(bool);
int static_assert(bool);
int unknown();
using namespace std;

void
////NR::zrhqr(Vec_I_DP & a, Vec_O_CPLX_DP & rt)
function()
{
  int a_dim1;
  assume(a_dim1 > 1);
  int rt_dim1;
  assume(rt_dim1 == a_dim1 - 1);

  int j, k;
  //complex < DP > x;

  int m = a_dim1 - 1;

  //Mat_DP hess(m, m);
  int hess_dim1 = m;
  int hess_dim2 = m;

  for (k = 0; k < m; k++)
    {
      //hess[0][k] = -a[m - k - 1] / a[m];
      //static_assert(0 <= 0);
      //static_assert(0 < hess_dim1);
      //static_assert(0 <= k);
      //static_assert(k < hess_dim2);
      //static_assert(0 <= m - k - 1);
      //static_assert(m - k - 1 < a_dim1);
      //static_assert(0 <= m);
      //static_assert(m < a_dim1);
      for (j = 1; j < m; j++)
	{
	  //hess[j][k] = 0.0;
	  //static_assert(0 <= j);
	  static_assert(j < hess_dim1);
	  //static_assert(0 <= k);
	  //static_assert(k < hess_dim2);
	}
      if (k != m - 1)
	{
	  //hess[k + 1][k] = 1.0;
	  //static_assert(0 <= k + 1);
	  //static_assert(k + 1 < hess_dim1);
	  //static_assert(0 <= k);
	  //static_assert(k < hess_dim2);
	}
    }
  // balanc(hess);
  // hqr(hess, rt);
  for (j = 1; j < m; j++)
    {
      //x = rt[j];
      //static_assert(0 <= j);
      //static_assert(j < rt_dim1);
      for (k = j - 1; k >= 0; k--)
	{
	  //static_assert(0 <= k);
	  //static_assert(k < rt_dim1);
	  if (unknown() /*real(rt[k]) <= real(x)*/)
	  {
	    break;
	  }
	  //rt[k + 1] = rt[k];
	  //static_assert(0 <= k + 1);
	  //static_assert(k + 1 < rt_dim1);
	  //static_assert(0 <= k);
	  //static_assert(k < rt_dim1);
	}
      //rt[k + 1] = x;
      //static_assert(0 <= k + 1);
      //static_assert(k + 1 < rt_dim1);
    }
}
