// Numerical Recipes in C++, 2nd edition, pg. 415

int assume(bool);
int static_assert(bool);
int unknown();

void
////NR::amoeba(Mat_IO_DP & p, Vec_IO_DP & y, const DP ftol, DP funk(Vec_I_DP &),
function()
{
  const int NMAX = 5000;
  //const DP TINY = 1.0e-10;
  int i, ihi, ilo, inhi, j;
  //DP rtol, ysave, ytry;

  int p_dim1;
  assume(p_dim1 > 1);
  int p_dim2;
  assume(p_dim2 == p_dim1 - 1);

  int x_dim1 = p_dim2;
  int y_dim1 = p_dim1;
  
  int mpts = p_dim1;
  int ndim = p_dim2;
  //Vec_DP psum(ndim);
  int psum_dim1 = ndim;

  // nfunk = 0;
  // get_psum(p, psum);
  for (;;)
    {
      ilo = 0;
      //ihi = y[0] > y[1] ? (inhi = 1, 0) : (inhi = 0, 1);
      //static_assert(0 <= 0);
      //static_assert(0 < y_dim1);
      //static_assert(0 <= 1);
      //static_assert(1 < y_dim1);
      if (unknown() /*y[0] > y[1]*/) {
	inhi = 1;
	ihi = 0;
      }
      else {
	inhi = 0;
	ihi = 1;
      }

      for (i = 0; i < mpts; i++)
	{
	  //static_assert(0 <= i);
	  //static_assert(i < y_dim1);
	  //static_assert(0 <= ilo);
	  //static_assert(ilo < y_dim1);
	  if (unknown() /*y[i] <= y[ilo]*/)
	    {
	      ilo = i;
	    }
	  //static_assert(0 <= i);
	  //static_assert(i < y_dim1);
	  //static_assert(0 <= ihi);
	  //static_assert(ihi < y_dim1);
	  if (unknown() /* y[i] > y[ihi] */)
	    {
	      inhi = ihi;
	      ihi = i;
	    }
	  else {
	    //static_assert(0 <= i);
	    //static_assert(i < y_dim1);
	    //static_assert(0 <= inhi);
	    //static_assert(inhi < y_dim1);
	    if (unknown() /*y[i] > y[inhi] && i != ihi*/)
	      {
		assume(i != ihi);
		inhi = i;
	      }
	  }
	}
      // rtol = 2.0 * fabs(y[ihi] - y[ilo]) / (fabs(y[ihi]) + fabs(y[ilo]) + TINY);
      //static_assert(0 <= ihi);
      static_assert(ihi < y_dim1);
      //static_assert(0 <= ilo);
      //static_assert(ilo < y_dim1);
      //static_assert(0 <= ihi);
      //static_assert(ihi < y_dim1);
      //static_assert(0 <= ilo);
      //static_assert(ilo < y_dim1);
      if (unknown() /*rtol < ftol*/)
	{
	  //SWAP(y[0], y[ilo]);
	  //static_assert(0 <= 0);
	  //static_assert(0 < y_dim1);
	  //static_assert(0 <= ilo);
	  //static_assert(ilo < y_dim1);
	  for (i = 0; i < ndim; i++)
	    {
	      //SWAP(p[0][i], p[ilo][i]);
	      //static_assert(0 <= 0);
	      //static_assert(0 < p_dim1);
	      //static_assert(0 <= i);
	      //static_assert(i < p_dim2);
	      //static_assert(0 <= ilo);
	      //static_assert(ilo < p_dim1);
	      //static_assert(0 <= i);
	      //static_assert(i < p_dim2);
	    }
	  break;
	}
      // if (nfunk >= NMAX)
      // 	{
      // 	  // nrerror("NMAX exceeded");
      // 	  return;
      // 	}
      // nfunk += 2;
      // ytry = amotry(p, y, psum, funk, ihi, -1.0);

      //static_assert(0 <= ilo);
      //static_assert(ilo < y_dim1);
      if (unknown() /*ytry <= y[ilo]*/)
	{
	  // ytry = amotry(p, y, psum, funk, ihi, 2.0);
	}
      else {
	//static_assert(0 <= inhi);
	//static_assert(inhi < y_dim1);
	if (unknown() /*ytry >= y[inhi]*/)
	{
	  //ysave = y[ihi];
	  //static_assert(0 <= ihi);
	  //static_assert(ihi < y_dim1);
	  // ytry = amotry(p, y, psum, funk, ihi, 0.5);
	  if (unknown() /*ytry >= ysave*/)
	    {
	      for (i = 0; i < mpts; i++)
		{
		  if (i != ilo)
		    {
		      for (j = 0; j < ndim; j++)
			{
			  //p[i][j] = psum[j] = 0.5 * (p[i][j] + p[ilo][j]);
			  //static_assert(0 <= i);
			  //static_assert(i < p_dim1);
			  //static_assert(0 <= j);
			  //static_assert(j < p_dim2);
			  //static_assert(0 <= j);
			  //static_assert(j < psum_dim1);
			  //static_assert(0 <= i);
			  //static_assert(i < p_dim1);
			  //static_assert(0 <= j);
			  //static_assert(j < p_dim2);
			  //static_assert(0 <= ilo);
			  //static_assert(ilo < p_dim1);
			  //static_assert(0 <= j);
			  //static_assert(j < p_dim2);
			}
		      //y[i] = funk(psum);
		      //static_assert(0 <= i);
		      //static_assert(i < y_dim1);
		    }
		}
	      // nfunk += ndim;
	      // get_psum(p, psum);
	    }
	}
	else
	  {
	    // --nfunk;
	  }
      }
    }
}
