// Numerical Recipes in C++, 2nd edition, pg. 916

int assume(bool);
int static_assert(bool);
int unknown();

void
//NR::arcode(unsigned long &ich, string & code, unsigned long &lcd,
function(int code_dim1, int lcd, int nch)
//     const int isign, arithcode & acode)
{
  assume(0 <= lcd);
  assume(lcd < code_dim1);

  int j, k, nc, ich;
  int ihi, ja, jh, jl, m;

  int ilob_dim1;
  assume(ilob_dim1 > 0);
  int iupb_dim1;
  assume(iupb_dim1 == ilob_dim1);

  int ncumfq_dim1;
  assume(ncumfq_dim1 == nch + 1);
  assume(nch > 0);
  
  int NWK = ilob_dim1;
  if (unknown() /*isign == 0*/)
    {
      // jdif = nrad - 1;
      for (j = NWK - 1; j >= 0; j--)
	{
	  //iupb[j] = nrad - 1;
	  //static_assert(0 <= j);
	  //static_assert(j < iupb_dim1);
	  //ilob[j] = 0;
	  //static_assert(0 <= j);
	  //static_assert(j < ilob_dim1);
	  nc = j;
	  if (unknown() /*jdif > minint*/)
	    {
	      return;
	    }
	  //jdif = (jdif + 1) * nrad - 1;
	}
      // nrerror("NWK too small in arcode.");
      return;
    }
  else
    {
      if (unknown() /*isign > 0*/)
	{
	  if (unknown() /*ich > nch*/)
	    {
	      // nrerror("bad ich in arcode.");
	      return;
	    }
	}
      else
	{
	  //ja = (unsigned char) code[lcd] - ilob[nc];
	  //static_assert(0 <= lcd);
	  //static_assert(lcd < code_dim1);
	  //static_assert(0 <= nc);
	  //static_assert(nc < ilob_dim1);
	  for (j = nc + 1; j < NWK; j++)
	    {
	      // ja *= nrad;
	      // ja +=
	      //((unsigned char) code[lcd + j - nc] -
	      //ilob[j]);
	      //static_assert(0 <= lcd + j - nc);
	      //static_assert(lcd + j - nc < code_dim1);
	      //static_assert(0 <= j);
	      //static_assert(j < ilob_dim1);
	    }
	  ihi = nch + 1;
	  ich = 0;
	  while (ihi - ich > 1)
	    {
	      m = (ich + ihi) / 2;
	      //static_assert(0 <= m);
	      //static_assert(m < ncumfq_dim1);
	      if (unknown() /*ja >= JTRY(jdif, ncumfq[m], ncum)*/)
		{
		  ich = m;
		}
	      else
		{
		  ihi = m;
		}
	    }
	  if (ich == nch)
	    {
	      return;
	    }
	}
      //jh = JTRY(jdif, ncumfq[ich + 1], ncum);
      //static_assert(0 <= ich + 1);
      //static_assert(ich + 1 < ncumfq_dim1);
      //jl = JTRY(jdif, ncumfq[ich], ncum);
      //static_assert(0 <= ich);
      //static_assert(ich < ncumfq_dim1);
      // jdif = jh - jl;
      // arcsum(ilob, iupb, jh, NWK, nrad, nc);
      // arcsum(ilob, ilob, jl, NWK, nrad, nc);
      for (j = nc; j < NWK; j++)
	{
	  //static_assert(0 <= j);
	  //static_assert(j < iupb_dim1);
	  //static_assert(0 <= j);
	  //static_assert(j < ilob_dim1);
	  if (unknown() /*ich != nch && iupb[j] != ilob[j]*/)
	    {
	      assume(ich != nch);
	      break;
	    }
	  if (unknown() /*isign > 0*/)
	    {
	      //code += (unsigned char) ilob[j];
	      //static_assert(0 <= j);
	      //static_assert(j < ilob_dim1);
	    }
	  lcd++;
	}
      if (j + 1 > NWK)
	{
	  return;
	}
      nc = j;
      // for (j = 0; jdif < minint; j++)
      // 	{
      // 	  jdif *= nrad;
      // 	}
      // if (j > nc)
      // 	{
      // 	  // nrerror("NWK too small in arcode.");
      // 	}
      j = unknown();
      assume(j <= nc);
      if (j != 0)
	{
	  for (k = nc; k < NWK; k++)
	    {
	      //iupb[k - j] = iupb[k];
	      //static_assert(0 <= k - j);
	      //static_assert(k - j < iupb_dim1);
	      //static_assert(0 <= k);
	      static_assert(k < iupb_dim1);
	      //ilob[k - j] = ilob[k];
	      //static_assert(0 <= k - j);
	      //static_assert(k - j < ilob_dim1);
	      //static_assert(0 <= k);
	      //static_assert(k < ilob_dim1);
	    }
	}
      nc -= j;
      for (k = NWK - j; k < NWK; k++)
	{
	  //iupb[k] = ilob[k] = 0;
	  //static_assert(0 <= k);
	  //static_assert(k < iupb_dim1);
	  //static_assert(0 <= k);
	  //static_assert(k < ilob_dim1);
	}
    }
  // return;
}
