// Numerical Recipes in C++, 2nd edition, pg. 772

int assume(bool);
int static_assert(bool);
int unknown();

//NR::bksub(const int ne, const int nb, const int jf, const int k1,
     //const int k2, Mat3D_IO_DP & c)
void function(const int ne, const int nb, const int jf, const int k1, const int k2)
{
  assume(ne >= nb);      
  assume(nb > 0);    
  assume(jf >= 0);
  assume(jf <= ne - nb);
  assume(k1 >= 0);  
  assume(k1 <= k2);  

  int c_dim1;
  assume(c_dim1 == ne);
  int c_dim2;
  assume(c_dim2 == ne - nb + 1);
  assume(c_dim2 > 0);  
  int c_dim3;
  assume(c_dim3 > k2);

  int nbf, im, kp, k, j, i;
  //DP xx;

  nbf = ne - nb;
  im = 1;
  for (k = k2 - 1; k >= k1; k--)
    {
      if (k == k1)
	{
	  im = nbf + 1;
	}
      kp = k + 1;
      for (j = 0; j < nbf; j++)
	{
	  //xx = c[j][jf][kp];
	  //static_assert(0 <= j);
	  //static_assert(j < c_dim1);
	  //static_assert(0 <= jf);
	  //static_assert(jf < c_dim2);
	  //static_assert(0 <= kp);
	  //static_assert(kp < c_dim3);
	  for (i = im - 1; i < ne; i++)
	    {
	      //c[i][jf][k] -= c[i][j][k] * xx;
	      //static_assert(0 <= i);
	      //static_assert(i < c_dim1);
	      //static_assert(0 <= jf);
	      //static_assert(jf < c_dim2);
	      //static_assert(0 <= k);
	      //static_assert(k < c_dim3);
	      //static_assert(0 <= i);
	      //static_assert(i < c_dim1);
	      //static_assert(0 <= j);
	      //static_assert(j < c_dim2);
	      //static_assert(0 <= k);
	      //static_assert(k < c_dim3);
	    }
	}
    }
  for (k = k1; k < k2; k++)
    {
      kp = k + 1;
      for (i = 0; i < nb; i++)
	{
	  //c[i][0][k] = c[i + nbf][jf][k];
	  //static_assert(0 <= i);
	  //static_assert(i < c_dim1);
	  //static_assert(0 <= 0);
	  static_assert(0 < c_dim2);
	  //static_assert(0 <= k);
	  //static_assert(k < c_dim3);
	  //static_assert(0 <= i + nbf);
	  //static_assert(i + nbf < c_dim1);
	  //static_assert(0 <= jf);
	  //static_assert(jf < c_dim2);
	  //static_assert(0 <= k);
	  //static_assert(k < c_dim3);
	}
      for (i = 0; i < nbf; i++)
	{
	  //c[i + nb][0][k] = c[i][jf][kp];
	  //static_assert(0 <= i + nb);
	  //static_assert(i + nb < c_dim1);
	  //static_assert(0 <= 0);
	  //static_assert(0 < c_dim2);
	  //static_assert(0 <= k);
	  //static_assert(k < c_dim3);
	  //static_assert(0 <= i);
	  //static_assert(i < c_dim1);
	  //static_assert(0 <= jf);
	  //static_assert(jf < c_dim2);
	  //static_assert(0 <= kp);
	  //static_assert(kp < c_dim3);
	}
    }
}
