// Numerical Recipes in C++, 2nd edition, pg. 640

#include <cmath>
int assume(bool);
int static_assert(bool);
int unknown();
using namespace std;

void
////NR::cntab2(Mat_I_INT & nn, DP & h, DP & hx, DP & hy, DP & hygx, DP & hxgy,
function()
//DP & uygx, DP & uxgy, DP & uxy)
{
  int nn_dim1;
  assume(nn_dim1 > 0);
  int nn_dim2;
  assume(nn_dim2 > 0);

  //const DP TINY = 1.0e-30;
  int i, j;
  //DP sum = 0.0, p;

  int ni = nn_dim1;
  int nj = nn_dim2;
  //Vec_DP sumi(ni), sumj(nj);
  int sumi_dim1 = ni;
  int sumj_dim1 = nj;

  for (i = 0; i < ni; i++)
    {
      //sumi[i] = 0.0;
      //static_assert(0 <= i);
      //static_assert(i < sumi_dim1);
      for (j = 0; j < nj; j++)
	{
	  //sumi[i] += nn[i][j];
	  static_assert(0 <= i);
	  //static_assert(i < sumi_dim1);
	  //static_assert(0 <= i);
	  //static_assert(i < nn_dim1);
	  //static_assert(0 <= j);
	  //static_assert(j < nn_dim2);
	  //sum += nn[i][j];
	  //static_assert(0 <= i);
	  //static_assert(i < nn_dim1);
	  //static_assert(0 <= j);
	  //static_assert(j < nn_dim2);
	}
    }
  for (j = 0; j < nj; j++)
    {
      //sumj[j] = 0.0;
      //static_assert(0 <= j);
      //static_assert(j < sumj_dim1);
      for (i = 0; i < ni; i++)
	{
	  //sumj[j] += nn[i][j];
	  //static_assert(0 <= j);
	  //static_assert(j < sumj_dim1);
	  //static_assert(0 <= i);
	  //static_assert(i < nn_dim1);
	  //static_assert(0 <= j);
	  //static_assert(j < nn_dim2);
	}
    }
  // hx = 0.0;
  for (i = 0; i < ni; i++) {
    //static_assert(0 <= i);
    //static_assert(i < sumi_dim1);
    if (unknown() /*sumi[i] != 0.0*/)
      {
	//p = sumi[i] / sum;
	//static_assert(0 <= i);
	//static_assert(i < sumi_dim1);
	//hx -= p * log(p);
      }
  }
  // hy = 0.0;
  for (j = 0; j < nj; j++) {
    //static_assert(0 <= j);
    //static_assert(j < sumj_dim1);
    if (unknown() /*sumj[j] != 0.0*/)
      {
	//p = sumj[j] / sum;
	//static_assert(0 <= j);
	//static_assert(j < sumj_dim1);
	//hy -= p * log(p);
      }
  }
  // h = 0.0;
  for (i = 0; i < ni; i++)
    for (j = 0; j < nj; j++) {
      //static_assert(0 <= i);
      //static_assert(i < nn_dim1);
      //static_assert(0 <= j);
      //static_assert(j < nn_dim2);
      if (unknown() /*nn[i][j] != 0*/)
	{
	  //p = nn[i][j] / sum;
	  //static_assert(0 <= i);
	  //static_assert(i < nn_dim1);
	  //static_assert(0 <= j);
	  //static_assert(j < nn_dim2);
	  //h -= p * log(p);
	}
    }
  // hygx = h - hx;
  // hxgy = h - hy;
  // uygx = (hy - hygx) / (hy + TINY);
  // uxgy = (hx - hxgy) / (hx + TINY);
  //uxy = 2.0 * (hx + hy - h) / (hx + hy + TINY);
}
