// Numerical Recipes in C++, 2nd edition, pg. 547

int assume(bool);
int static_assert(bool);
int unknown();

void
////NR::convlv(Vec_I_DP & data, Vec_I_DP & respns, const int isign,
function(int isign)
//Vec_O_DP & ans)
{
  int data_dim1;
  assume(data_dim1 > 1);
  int ans_dim1;
  assume(ans_dim1 == data_dim1);
  int respns_dim1;
  assume(respns_dim1 > 0);

  int i, no2;
  //DP mag2, tmp;

  int n = data_dim1;
  int m = respns_dim1;
  //Vec_DP temp(n);
  int temp_dim1 = n;
  //temp[0] = respns[0];
  //static_assert(0 <= 0);
  //static_assert(0 < temp_dim1);
  //static_assert(0 <= 0);
  //static_assert(0 < respns_dim1);
  for (i = 1; i < (m + 1) / 2; i++)
    {
      //temp[i] = respns[i];
      //static_assert(0 <= i);
      //static_assert(i < temp_dim1);
      static_assert(0 <= i);
      //static_assert(i < respns_dim1);
      //temp[n - i] = respns[m - i];
      //static_assert(0 <= n - i);
      //static_assert(n - i < temp_dim1);
      //static_assert(0 <= m - i);
      //static_assert(m - i < respns_dim1);
    }
  for (i = (m + 1) / 2; i < n - (m - 1) / 2; i++)
    {
      //temp[i] = 0.0;
      //static_assert(0 <= i);
      //static_assert(i < temp_dim1);
    }
  for (i = 0; i < n; i++)
    {
      //ans[i] = data[i];
      //static_assert(0 <= i);
      //static_assert(i < ans_dim1);
      //static_assert(0 <= i);
      //static_assert(i < data_dim1);
    }
  // realft(ans, 1);
  // realft(temp, 1);
  no2 = n / 2;
  if (isign == 1)
    {
      for (i = 2; i < n; i += 2)
	{
	  //tmp = ans[i];
	  //static_assert(0 <= i);
	  //static_assert(i < ans_dim1);
	  //ans[i] = (ans[i] * temp[i] - ans[i + 1] * temp[i + 1]) / no2;
	  //static_assert(0 <= i);
	  //static_assert(i < ans_dim1);
	  //static_assert(0 <= i);
	  //static_assert(i < ans_dim1);
	  //static_assert(0 <= i);
	  //static_assert(i < temp_dim1);
	  //static_assert(0 <= i + 1);
	  //static_assert(i + 1 < ans_dim1);
	  //static_assert(0 <= i + 1);
	  //static_assert(i + 1 < temp_dim1);
	  //ans[i + 1] = (ans[i + 1] * temp[i] + tmp * temp[i + 1]) / no2;
	  //static_assert(0 <= i + 1);
	  //static_assert(i + 1 < ans_dim1);
	  //static_assert(0 <= i + 1);
	  //static_assert(i + 1 < ans_dim1);
	  //static_assert(0 <= i);
	  //static_assert(i < temp_dim1);
	  //static_assert(0 <= i + 1);
	  //static_assert(i + 1 < temp_dim1);
	}
      //ans[0] = ans[0] * temp[0] / no2;
      //static_assert(0 <= 0);
      //static_assert(0 < ans_dim1);
      //static_assert(0 <= 0);
      //static_assert(0 < ans_dim1);
      //static_assert(0 <= 0);
      //static_assert(0 < temp_dim1);
      //ans[1] = ans[1] * temp[1] / no2;
      //static_assert(0 <= 1);
      //static_assert(1 < ans_dim1);
      //static_assert(0 <= 1);
      //static_assert(1 < ans_dim1);
      //static_assert(0 <= 1);
      //static_assert(1 < temp_dim1);
    }
  else if (isign == -1)
    {
      for (i = 2; i < n; i += 2)
	{
	  //static_assert(0 <= i);
	  //static_assert(i < temp_dim1);
	  //static_assert(0 <= i + 1);
	  //static_assert(i + 1 < temp_dim1);
	  if (unknown()/*(mag2 = SQR(temp[i]) + SQR(temp[i + 1])) == 0.0*/)
	  {
	    // nrerror("Deconvolving at response zero in convlv");
	    return;
	  }
	  //tmp = ans[i];
	  //static_assert(0 <= i);
	  //static_assert(i < ans_dim1);
	  //ans[i] = (ans[i] * temp[i] + ans[i + 1] * temp[i + 1]) / mag2 / no2;
	  //static_assert(0 <= i);
	  //static_assert(i < ans_dim1);
	  //static_assert(0 <= i);
	  //static_assert(i < ans_dim1);
	  //static_assert(0 <= i);
	  //static_assert(i < temp_dim1);
	  //static_assert(0 <= i + 1);
	  //static_assert(i + 1 < ans_dim1);
	  //static_assert(0 <= i + 1);
	  //static_assert(i + 1 < temp_dim1);
	  //ans[i + 1] =
	  //(ans[i + 1] * temp[i] - tmp * temp[i + 1]) / mag2 / no2;
	  //static_assert(0 <= i + 1);
	  //static_assert(i + 1 < ans_dim1);
	  //static_assert(0 <= i + 1);
	  //static_assert(i + 1 < ans_dim1);
	  //static_assert(0 <= i);
	  //static_assert(i < temp_dim1);
	  //static_assert(0 <= i + 1);
	  //static_assert(i + 1 < temp_dim1);
	}

      //static_assert(0 <= 0);
      //static_assert(0 < temp_dim1);
      //static_assert(0 <= 1);
      //static_assert(1 < temp_dim1);
      if (unknown() /*temp[0] == 0.0 || temp[1] == 0.0*/)
      {
	// nrerror("Deconvolving at response zero in convlv");
	return;
      }
      //ans[0] = ans[0] / temp[0] / no2;
      //static_assert(0 <= 0);
      //static_assert(0 < ans_dim1);
      //static_assert(0 <= 0);
      //static_assert(0 < ans_dim1);
      //static_assert(0 <= 0);
      //static_assert(0 < temp_dim1);
      //ans[1] = ans[1] / temp[1] / no2;
      //static_assert(0 <= 1);
      //static_assert(1 < ans_dim1);
      //static_assert(0 <= 1);
      //static_assert(1 < ans_dim1);
      //static_assert(0 <= 1);
      //static_assert(1 < temp_dim1);
    }
  else
    {
      // nrerror("No meaning for isign in convlv");
      return;
    }
  // realft(ans, -1);
}
