// Numerical Recipes in C++, 2nd edition, pg. 587

#include <cmath>
int assume(bool);
int static_assert(bool);
int unknown();
using namespace std;

void
////NR::fasper(Vec_I_DP & x, Vec_I_DP & y, const DP ofac, const DP hifac,
function(int nout)
//Vec_O_DP & wk1, Vec_O_DP & wk2, int &nout, int &jmax, DP & prob)
{
  const int MACC = 4;


  int j, k, ndim, nfreq, nfreqt;
  //DP ave, ck, ckk, cterm, cwt, den, df, effm, expy, fac, fndim, hc2wt,
  // hs2wt, hypo, pmax, sterm, swt, var, xdif, xmax, xmin;

  int x_dim1;
  assume(x_dim1 > 0);
  int y_dim1;
  assume(y_dim1 == x_dim1);
  int wk1_dim1;
  assume(wk1_dim1 > 0);
  int wk2_dim1;
  assume(wk2_dim1 == wk1_dim1);
  
  int n = x_dim1;
  int nwk = wk1_dim1;
  //nout = 0.5 * ofac * hifac * n;  
  assume(nout <= nwk);

  //nfreqt = ofac * hifac * n * MACC;
  // nfreq = 64;
  // while (nfreq < nfreqt)
  //   {
  //     nfreq <<= 1;
  //   }
  // ndim = nfreq << 1;
  // if (ndim > nwk)
  //   {
  //     nrerror("workspaces too small in fasper");
  //   }
  assume(ndim <= nwk);
  assume(2*nout + 2 <= ndim);
  
  // avevar(y, ave, var);
  // if (var == 0.0)
  //   {
  //     nrerror("zero variance in fasper");
  //   }
  //xmin = x[0];
  //static_assert(0 <= 0);
  //static_assert(0 < x_dim1);
  // xmax = xmin;
  for (j = 1; j < n; j++)
    {
      //static_assert(0 <= j);
      //static_assert(j < x_dim1);
      if (unknown() /*x[j] < xmin*/)
	{
	  //xmin = x[j];
	  //static_assert(0 <= j);
	  //static_assert(j < x_dim1);
	}
      //static_assert(0 <= j);
      //static_assert(j < x_dim1);
      if (unknown() /*x[j] > xmax*/)
	{
	  //xmax = x[j];
	  //static_assert(0 <= j);
	  //static_assert(j < x_dim1);
	}
    }
  // xdif = xmax - xmin;

  //Vec_DP wk1_t(0.0, ndim);
  //Vec_DP wk2_t(0.0, ndim);
  int wk1_t_dim1 = ndim;
  int wk2_t_dim1 = ndim;

  // fac = ndim / (xdif * ofac);
  // fndim = ndim;
  for (j = 0; j < n; j++)
    {
      //ck = fmod((x[j] - xmin) * fac, fndim);
      //static_assert(0 <= j);
      //static_assert(j < x_dim1);
      //ckk = 2.0 * (ck++);
      // ckk = fmod(ckk, fndim);
      // ++ckk;
      //spread(y[j] - ave, wk1_t, ck, MACC);
      static_assert(0 <= j);
      //static_assert(j < y_dim1);
      // spread(1.0, wk2_t, ckk, MACC);
    }
  // realft(wk1_t, 1);
  // realft(wk2_t, 1);
  //df = 1.0 / (xdif * ofac);
  // pmax = -1.0;
  for (k = 2, j = 0; j < nout; j++, k += 2)
    {
      //hypo = sqrt(wk2_t[k] * wk2_t[k] + wk2_t[k + 1] * wk2_t[k + 1]);
      //static_assert(0 <= k);
      //static_assert(k < wk2_t_dim1);
      //static_assert(0 <= k);
      //static_assert(k < wk2_t_dim1);
      //static_assert(0 <= k + 1);
      //static_assert(k + 1 < wk2_t_dim1);
      //static_assert(0 <= k + 1);
      //static_assert(k + 1 < wk2_t_dim1);
      //hc2wt = 0.5 * wk2_t[k] / hypo;
      //static_assert(0 <= k);
      //static_assert(k < wk2_t_dim1);
      //hs2wt = 0.5 * wk2_t[k + 1] / hypo;
     //static_assert(0 <= k + 1);
      //static_assert(k + 1 < wk2_t_dim1);
      // cwt = sqrt(0.5 + hc2wt);
      // swt = SIGN(sqrt(0.5 - hc2wt), hs2wt);
      //den = 0.5 * n + hc2wt * wk2_t[k] + hs2wt * wk2_t[k + 1];
      //static_assert(0 <= k);
      //static_assert(k < wk2_t_dim1);
      //static_assert(0 <= k + 1);
      //static_assert(k + 1 < wk2_t_dim1);
      //cterm = SQR(cwt * wk1_t[k] + swt * wk1_t[k + 1]) / den;
      //static_assert(0 <= k);
      //static_assert(k < wk1_t_dim1);
      //static_assert(0 <= k + 1);
      //static_assert(k + 1 < wk1_t_dim1);
      //sterm = SQR(cwt * wk1_t[k + 1] - swt * wk1_t[k]) / (n - den);
      //static_assert(0 <= k + 1);
      //static_assert(k + 1 < wk1_t_dim1);
      //static_assert(0 <= k);
      //static_assert(k < wk1_t_dim1);
      //wk1[j] = (j + 1) * df;
      //static_assert(0 <= j);
      //static_assert(j < wk1_dim1);
      //wk2[j] = (cterm + sterm) / (2.0 * var);
      //static_assert(0 <= j);
      //static_assert(j < wk2_dim1);

      //static_assert(0 <= j);
      //static_assert(j < wk2_dim1);
      if (unknown() /*wk2[j] > pmax*/)
	{
	  // jmax = j;
	  //pmax = wk2[j];
	  //static_assert(0 <= j);
	  //static_assert(j < wk2_dim1);
	}
    }
  // expy = exp(-pmax);
  //effm = 2.0 * nout / ofac;
  //prob = effm * expy;
  // if (prob > 0.01)
  //   {
  //     prob = 1.0 - pow(1.0 - expy, effm);
  //   }
}
