// Numerical Recipes in C++, 2nd edition, pg. 512

#include <cmath>
int assume(bool);
int static_assert(bool);
int unknown();
using namespace std;

void
////NR::four1(Vec_IO_DP & data, const int isign)
function()
{
  int data_dim1;
  assume(data_dim1 > 0);

  int n, mmax, m, j, istep, i;
  //DP wtemp, wr, wpr, wpi, wi, theta, tempr, tempi;

  int nn = data_dim1 / 2;
  n = 2*nn;
  j = 1;
  for (i = 1; i < n; i += 2)
    {
      if (j > i)
	{
	  //SWAP(data[j - 1], data[i - 1]);
	  //static_assert(0 <= j - 1);
	  //static_assert(j - 1 < data_dim1);
	  //static_assert(0 <= i - 1);
	  //static_assert(i - 1 < data_dim1);
	  //SWAP(data[j], data[i]);
	  //static_assert(0 <= j);
	  //static_assert(j < data_dim1);
	  //static_assert(0 <= i);
	  //static_assert(i < data_dim1);
	}
      m = nn;
      while (m >= 2 && j > m)
	{
	  j -= m;
	  m = m/2;
	}
      j += m;
    }
  mmax = 2;
  while (n > mmax)
    {
      istep = 2*mmax;
      //theta = isign * (6.28318530717959 / mmax);
      //wtemp = sin(0.5 * theta);
      //wpr = -2.0 * wtemp * wtemp;
      // wpi = sin(theta);
      // wr = 1.0;
      // wi = 0.0;
      for (m = 1; m < mmax; m += 2)
	{
	  for (i = m; i <= n; i += istep)
	    {
	      j = i + mmax;
	      //tempr = wr * data[j - 1] - wi * data[j];
	      //static_assert(0 <= j - 1);
	      //static_assert(j - 1 < data_dim1);
	      //static_assert(0 <= j);
	      //static_assert(j < data_dim1);
	      //tempi = wr * data[j] + wi * data[j - 1];
	      //static_assert(0 <= j);
	      //static_assert(j < data_dim1);
	      //static_assert(0 <= j - 1);
	      //static_assert(j - 1 < data_dim1);
	      //data[j - 1] = data[i - 1] - tempr;
	      //static_assert(0 <= j - 1);
	      //static_assert(j - 1 < data_dim1);
	      //static_assert(0 <= i - 1);
	      //static_assert(i - 1 < data_dim1);
	      //data[j] = data[i] - tempi;
	      //static_assert(0 <= j);
	      //static_assert(j < data_dim1);
	      static_assert(0 <= i);
	      //static_assert(i < data_dim1);
	      //data[i - 1] += tempr;
	      //static_assert(0 <= i - 1);
	      //static_assert(i - 1 < data_dim1);
	      //data[i] += tempi;
	      //static_assert(0 <= i);
	      //static_assert(i < data_dim1);
	    }
	  //wr = (wtemp = wr) * wpr - wi * wpi + wr;
	  //wi = wi * wpr + wtemp * wpi + wi;
	}
      mmax = istep;
    }
}
