// Numerical Recipes in C++, 2nd edition, pg. 495

int assume(bool);
int static_assert(bool);
int unknown();

void
////NR::hqr(Mat_IO_DP & a, Vec_O_CPLX_DP & wri)
function()
{

  int a_dim1;
  assume(a_dim1 > 0);
  int a_dim2;
  assume(a_dim2 == a_dim1);
  int wri_dim1;
  assume(wri_dim1 == a_dim1);

  int nn, m, l, k, j, its, i, mmin;
  //DP z, y, x, w, v, u, t, s, r, q, p, anorm;

  int n = a_dim1;
  // anorm = 0.0;
  for (i = 0; i < n; i++) {
    int tmp;
    if (i-1 < 0) tmp = 0;
    else         tmp = i-1;
    for (j = tmp /*MAX(i - 1, 0)*/; j < n; j++)
      {
	//anorm += fabs(a[i][j]);
	//static_assert(0 <= i);
	//static_assert(i < a_dim1);
	//static_assert(0 <= j);
	//static_assert(j < a_dim2);
      }
  }
  nn = n - 1;
  // t = 0.0;
  while (nn >= 0)
    {
      its = 0;
      do
	{
	  for (l = nn; l > 0; l--)
	    {
	      //s = fabs(a[l - 1][l - 1]) + fabs(a[l][l]);
	      //static_assert(0 <= l - 1);
	      //static_assert(l - 1 < a_dim1);
	      //static_assert(0 <= l - 1);
	      //static_assert(l - 1 < a_dim2);
	      //static_assert(0 <= l);
	      //static_assert(l < a_dim1);
	      //static_assert(0 <= l);
	      //static_assert(l < a_dim2);
	      // if (s == 0.0)
	      // 	{
	      // 	  s = anorm;
	      // 	}

	      //static_assert(0 <= l);
	      //static_assert(l < a_dim1);
	      //static_assert(0 <= l - 1);
	      //static_assert(l - 1 < a_dim2);
	      if (unknown() /*fabs(a[l][l - 1]) + s == s*/)
	      {
		//a[l][l - 1] = 0.0;
		//static_assert(0 <= l);
		//static_assert(l < a_dim1);
		//static_assert(0 <= l - 1);
		//static_assert(l - 1 < a_dim2);
		break;
	      }
	    }
	  //x = a[nn][nn];
	  //static_assert(0 <= nn);
	  //static_assert(nn < a_dim1);
	  //static_assert(0 <= nn);
	  //static_assert(nn < a_dim2);
	  if (l == nn)
	    {
	      //wri[nn--] = x + t;
	      //static_assert(0 <= nn);
	      //static_assert(nn < wri_dim1);
	      nn--;	      
	    }
	  else
	    {
	      //y = a[nn - 1][nn - 1];
	      //static_assert(0 <= nn - 1);
	      //static_assert(nn - 1 < a_dim1);
	      //static_assert(0 <= nn - 1);
	      //static_assert(nn - 1 < a_dim2);
	      //w = a[nn][nn - 1] * a[nn - 1][nn];
	      //static_assert(0 <= nn);
	      //static_assert(nn < a_dim1);
	      //static_assert(0 <= nn - 1);
	      //static_assert(nn - 1 < a_dim2);
	      //static_assert(0 <= nn - 1);
	      //static_assert(nn - 1 < a_dim1);
	      //static_assert(0 <= nn);
	      //static_assert(nn < a_dim2);
	      if (l == nn - 1)
		{
		  //p = 0.5 * (y - x);
		  //q = p * p + w;
		  // z = sqrt(fabs(q));
		  // x += t;
		  if (unknown() /*q >= 0.0*/)
		    {
		      // z = p + SIGN(z, p);
		      //wri[nn - 1] = wri[nn] = x + z;
		      //static_assert(0 <= nn - 1);
		      //static_assert(nn - 1 < wri_dim1);
		      //static_assert(0 <= nn);
		      //static_assert(nn < wri_dim1);
		      if (unknown() /*z != 0.0*/)
			{
			  //wri[nn] = x - w / z;
			  //static_assert(0 <= nn);
			  //static_assert(nn < wri_dim1);
			}
		    }
		  else
		    {
		      //wri[nn] = complex < DP > (x + p, z);
		      //static_assert(0 <= nn);
		      //static_assert(nn < wri_dim1);
		      //wri[nn - 1] = conj(wri[nn]);
		      //static_assert(0 <= nn - 1);
		      //static_assert(nn - 1 < wri_dim1);
		      //static_assert(0 <= nn);
		      //static_assert(nn < wri_dim1);
		    }
		  nn -= 2;
		}
	      else
		{
		  if (its == 30)
		    {
		      // nrerror("Too many iterations in hqr");
		      return;
		    }
		  if (its == 10 || its == 20)
		    {
		      // t += x;
		      for (i = 0; i < nn + 1; i++)
			{
			  //a[i][i] -= x;
			  //static_assert(0 <= i);
			  //static_assert(i < a_dim1);
			  //static_assert(0 <= i);
			  //static_assert(i < a_dim2);
			}
		      //s = fabs(a[nn][nn - 1]) + fabs(a[nn - 1][nn - 2]);
		      //static_assert(0 <= nn);
		      //static_assert(nn < a_dim1);
		      //static_assert(0 <= nn - 1);
		      //static_assert(nn - 1 < a_dim2);
		      //static_assert(0 <= nn - 1);
		      //static_assert(nn - 1 < a_dim1);
		      //static_assert(0 <= nn - 2);
		      //static_assert(nn - 2 < a_dim2);
		      //y = x = 0.75 * s;
		      //w = -0.4375 * s * s;
		    }
		  ++its;
		  for (m = nn - 2; m >= l; m--)
		    {
		      //z = a[m][m];
		      //static_assert(0 <= m);
		      //static_assert(m < a_dim1);
		      //static_assert(0 <= m);
		      //static_assert(m < a_dim2);
		      // r = x - z;
		      // s = y - z;
		      //p = (r * s - w) / a[m + 1][m] + a[m][m + 1];
		      //static_assert(0 <= m + 1);
		      //static_assert(m + 1 < a_dim1);
		      //static_assert(0 <= m);
		      //static_assert(m < a_dim2);
		      //static_assert(0 <= m);
		      //static_assert(m < a_dim1);
		      //static_assert(0 <= m + 1);
		      //static_assert(m + 1 < a_dim2);
		      //q = a[m + 1][m + 1] - z - r - s;
		      //static_assert(0 <= m + 1);
		      //static_assert(m + 1 < a_dim1);
		      //static_assert(0 <= m + 1);
		      //static_assert(m + 1 < a_dim2);
		      //r = a[m + 2][m + 1];
		      //static_assert(0 <= m + 2);
		      //static_assert(m + 2 < a_dim1);
		      //static_assert(0 <= m + 1);
		      //static_assert(m + 1 < a_dim2);
		      // s = fabs(p) + fabs(q) + fabs(r);
		      // p /= s;
		      // q /= s;
		      // r /= s;
		      if (m == l)
			{
			  break;
			}
		      //u = fabs(a[m][m - 1]) * (fabs(q) + fabs(r));
		      //static_assert(0 <= m);
		      //static_assert(m < a_dim1);
		      //static_assert(0 <= m - 1);
		      //static_assert(m - 1 < a_dim2);
		      // v = fabs(p) * (fabs(a[m - 1][m - 1]) + fabs(z) +
		      //fabs(a[m + 1][m + 1]));
		      //static_assert(0 <= m - 1);
		      //static_assert(m - 1 < a_dim1);
		      //static_assert(0 <= m - 1);
		      //static_assert(m - 1 < a_dim2);

		      //static_assert(0 <= m + 1);
		      //static_assert(m + 1 < a_dim1);
		      //static_assert(0 <= m + 1);
		      //static_assert(m + 1 < a_dim2);
		      // if (u + v == v)
		      // 	{
		      // 	  break;
		      // 	}
		    }
		  for (i = m; i < nn - 1; i++)
		    {
		      //a[i + 2][i] = 0.0;
		      static_assert(0 <= i + 2);
		      //static_assert(i + 2 < a_dim1);
		      //static_assert(0 <= i);
		      //static_assert(i < a_dim2);
		      if (i != m)
			{
			  //a[i + 2][i - 1] = 0.0;
			  //static_assert(0 <= i + 2);
			  //static_assert(i + 2 < a_dim1);
			  //static_assert(0 <= i - 1);
			  //static_assert(i - 1 < a_dim2);
			}
		    }
		  for (k = m; k < nn; k++)
		    {
		      if (k != m)
			{
			  //p = a[k][k - 1];
			  //static_assert(0 <= k);
			  //static_assert(k < a_dim1);
			  //static_assert(0 <= k - 1);
			  //static_assert(k - 1 < a_dim2);
			  //q = a[k + 1][k - 1];
			  //static_assert(0 <= k + 1);
			  //static_assert(k + 1 < a_dim1);
			  //static_assert(0 <= k - 1);
			  //static_assert(k - 1 < a_dim2);
			  // r = 0.0;
			  if (k + 1 != nn)
			    {
			      //r = a[k + 2][k - 1];
			      //static_assert(0 <= k + 2);
			      //static_assert(k + 2 < a_dim1);
			      //static_assert(0 <= k - 1);
			      //static_assert(k - 1 < a_dim2);
			    }
			  // if ((x = fabs(p) + fabs(q) + fabs(r)) != 0.0)
			  //   {
			  //     p /= x;
			  //     q /= x;
			  //     r /= x;
			  //   }
			}
		      if (unknown() /*(s = SIGN(sqrt(p * p + q * q + r * r), p)) != 0.0*/)
		      {
			if (k == m)
			  {
			    if (l != m)
			      {
				//a[k][k - 1] = -a[k][k - 1];
				//static_assert(0 <= k);
				//static_assert(k < a_dim1);
				//static_assert(0 <= k - 1);
				//static_assert(k - 1 < a_dim2);
				//static_assert(0 <= k);
				//static_assert(k < a_dim1);
				//static_assert(0 <= k - 1);
				//static_assert(k - 1 < a_dim2);
			      }
			  }
			else
			  {
			    //a[k][k - 1] = -s * x;
			    //static_assert(0 <= k);
			    //static_assert(k < a_dim1);
			    //static_assert(0 <= k - 1);
			    //static_assert(k - 1 < a_dim2);
			  }
			// p += s;
			// x = p / s;
			// y = q / s;
			// z = r / s;
			// q /= p;
			// r /= p;
			for (j = k; j < nn + 1; j++)
			  {
			    //p = a[k][j] + q * a[k + 1][j];
			    //static_assert(0 <= k);
			    //static_assert(k < a_dim1);
			    //static_assert(0 <= j);
			    //static_assert(j < a_dim2);
			    //static_assert(0 <= k + 1);
			    //static_assert(k + 1 < a_dim1);
			    //static_assert(0 <= j);
			    //static_assert(j < a_dim2);
			    if (k + 1 != nn)
			      {
				//p += r * a[k + 2][j];
				//static_assert(0 <= k + 2);
				//static_assert(k + 2 < a_dim1);
				//static_assert(0 <= j);
				//static_assert(j < a_dim2);
				//a[k + 2][j] -= p * z;
				//static_assert(0 <= k + 2);
				//static_assert(k + 2 < a_dim1);
				//static_assert(0 <= j);
				//static_assert(j < a_dim2);
			      }
			    //a[k + 1][j] -= p * y;
			    //static_assert(0 <= k + 1);
			    //static_assert(k + 1 < a_dim1);
			    //static_assert(0 <= j);
			    //static_assert(j < a_dim2);
			    //a[k][j] -= p * x;
			    //static_assert(0 <= k);
			    //static_assert(k < a_dim1);
			    //static_assert(0 <= j);
			    //static_assert(j < a_dim2);
			  }
			// mmin = nn < k + 3 ? nn : k + 3;
			if (nn < k+3) {
			  mmin = nn;
			}
			else {
			  mmin = k+3;
			}
			for (i = l; i < mmin + 1; i++)
			  {
			    //p = x * a[i][k] + y * a[i][k + 1];
			    //static_assert(0 <= i);
			    //static_assert(i < a_dim1);
			    //static_assert(0 <= k);
			    //static_assert(k < a_dim2);
			    //static_assert(0 <= i);
			    //static_assert(i < a_dim1);
			    //static_assert(0 <= k + 1);
			    //static_assert(k + 1 < a_dim2);
			    if (k != (nn))
			      {
				//p += z * a[i][k + 2];
				//static_assert(0 <= i);
				//static_assert(i < a_dim1);
				//static_assert(0 <= k + 2);
				//static_assert(k + 2 < a_dim2);
				//a[i][k + 2] -= p * r;
				//static_assert(0 <= i);
				//static_assert(i < a_dim1);
				//static_assert(0 <= k + 2);
				//static_assert(k + 2 < a_dim2);
			      }
			    //a[i][k + 1] -= p * q;
			    //static_assert(0 <= i);
			    //static_assert(i < a_dim1);
			    //static_assert(0 <= k + 1);
			    //static_assert(k + 1 < a_dim2);
			    //a[i][k] -= p;
			    //static_assert(0 <= i);
			    //static_assert(i < a_dim1);
			    //static_assert(0 <= k);
			    //static_assert(k < a_dim2);
			  }
		      }
		    }
		}
	    }
	}
      while (l + 1 < nn);
    }
}
