// Numerical Recipes in C++, 2nd edition, pg. 584

#include <cmath>
int assume(bool);
int static_assert(bool);
int unknown();
using namespace std;

void
////NR::period(Vec_I_DP & x, Vec_I_DP & y, const DP ofac, const DP hifac,
function(int nout, int jmax)
     //Vec_O_DP & px, Vec_O_DP & py, int &nout, int &jmax, DP & prob)
{
  //const DP TWOPI = 6.283185307179586476;
  int i, j;
  //DP ave, c, cc, cwtau, effm, expy, pnow, pymax, s, ss, sumc, sumcy,
  // sums, sumsh, sumsy, swtau, var, wtau, xave, xdif, xmax, xmin, yy,
  //   arg, wtemp;

  int x_dim1;
  assume(x_dim1 > 0);
  int y_dim1;
  assume(y_dim1 == x_dim1);

  int px_dim1;
  assume(px_dim1 > 0);
  int py_dim1;
  assume(py_dim1 == px_dim1);

  int n = x_dim1;
  int np = px_dim1;

  //Vec_DP wi(n), wpi(n), wpr(n), wr(n);
  int  wi_dim1 = n;
  int wpi_dim1 = n;
  int wpr_dim1 = n;
  int  wr_dim1 = n;

  //nout = 0.5 * ofac * hifac * n;
  if (nout > np)
    {
      // nrerror("output arrays too short in period");
      return;
    }
  // avevar(y, ave, var);
  // if (var == 0.0)
  //   {
  //     nrerror("zero variance in period");
  //   }
  //xmax = xmin = x[0];
  //static_assert(0 <= 0);
  //static_assert(0 < x_dim1);
  for (j = 0; j < n; j++)
    {
      //static_assert(0 <= j);
      //static_assert(j < x_dim1);
      if (unknown() /*x[j] > xmax*/)
      {
	//xmax = x[j];
	//static_assert(0 <= j);
	//static_assert(j < x_dim1);
      }
      if (unknown() /*x[j] < xmin*/)
      //static_assert(0 <= j);
      //static_assert(j < x_dim1);
      {
	//xmin = x[j];
	//static_assert(0 <= j);
	static_assert(j < x_dim1);
      }
    }
  // xdif = xmax - xmin;
  //xave = 0.5 * (xmax + xmin);
  // pymax = 0.0;
  //pnow = 1.0 / (xdif * ofac);
  for (j = 0; j < n; j++)
    {
      //arg = TWOPI * ((x[j] - xave) * pnow);
      //static_assert(0 <= j);
      //static_assert(j < x_dim1);
      //wpr[j] = -2.0 * SQR(sin(0.5 * arg));
      //static_assert(0 <= j);
      //static_assert(j < wpr_dim1);
      //wpi[j] = sin(arg);
      //static_assert(0 <= j);
      //static_assert(j < wpi_dim1);
      //wr[j] = cos(arg);
      //static_assert(0 <= j);
      //static_assert(j < wr_dim1);
      //wi[j] = wpi[j];
      //static_assert(0 <= j);
      //static_assert(j < wi_dim1);
      //static_assert(0 <= j);
      //static_assert(j < wpi_dim1);
    }
  for (i = 0; i < nout; i++)
    {
      //px[i] = pnow;
      //static_assert(0 <= i);
      //static_assert(i < px_dim1);
      // sumsh = sumc = 0.0;
      for (j = 0; j < n; j++)
	{
	  //c = wr[j];
	  //static_assert(0 <= j);
	  //static_assert(j < wr_dim1);
	  //s = wi[j];
	  //static_assert(0 <= j);
	  //static_assert(j < wi_dim1);
	  //sumsh += s * c;
	  //sumc += (c - s) * (c + s);
	}
      //wtau = 0.5 * atan2(2.0 * sumsh, sumc);
      // swtau = sin(wtau);
      // cwtau = cos(wtau);
      // sums = sumc = sumsy = sumcy = 0.0;
      for (j = 0; j < n; j++)
	{
	  //s = wi[j];
	  //static_assert(0 <= j);
	  //static_assert(j < wi_dim1);
	  //c = wr[j];
	  //static_assert(0 <= j);
	  //static_assert(j < wr_dim1);
	  //ss = s * cwtau - c * swtau;
	  //cc = c * cwtau + s * swtau;
	  //sums += ss * ss;
	  //sumc += cc * cc;
	  //yy = y[j] - ave;
	  //static_assert(0 <= j);
	  //static_assert(j < y_dim1);
	  //sumsy += yy * ss;
	  //sumcy += yy * cc;
	  //wr[j] = ((wtemp = wr[j]) * wpr[j] - wi[j] * wpi[j]) + wr[j];
	  //static_assert(0 <= j);
	  //static_assert(j < wr_dim1);
	  //static_assert(0 <= j);
	  //static_assert(j < wr_dim1);
	  //static_assert(0 <= j);
	  //static_assert(j < wpr_dim1);
	  //static_assert(0 <= j);
	  //static_assert(j < wi_dim1);
	  //static_assert(0 <= j);
	  //static_assert(j < wpi_dim1);
	  //static_assert(0 <= j);
	  //static_assert(j < wr_dim1);
	  //wi[j] = (wi[j] * wpr[j] + wtemp * wpi[j]) + wi[j];
	  //static_assert(0 <= j);
	  //static_assert(j < wi_dim1);
	  //static_assert(0 <= j);
	  //static_assert(j < wi_dim1);
	  //static_assert(0 <= j);
	  //static_assert(j < wpr_dim1);
	  //static_assert(0 <= j);
	  //static_assert(j < wpi_dim1);
	  //static_assert(0 <= j);
	  //static_assert(j < wi_dim1);
	}
      //py[i] = 0.5 * (sumcy * sumcy / sumc + sumsy * sumsy / sums) / var;
      //static_assert(0 <= i);
      //static_assert(i < py_dim1);

      //static_assert(0 <= i);
      //static_assert(i < py_dim1);
      if (unknown() /*py[i] >= pymax*/)
      {
	jmax = i;
	//pymax = py[jmax];
	//static_assert(0 <= jmax);
	//static_assert(jmax < py_dim1);

      }
      //pnow += 1.0 / (ofac * xdif);
    }
  // expy = exp(-pymax);
  //effm = 2.0 * nout / ofac;
  //prob = effm * expy;
  // if (prob > 0.01)
  //   {
  //     prob = 1.0 - pow(1.0 - expy, effm);
  //   }
}
