// Numerical Recipes in C++, 2nd edition, pg. 284

int assume(bool);
int static_assert(bool);
int unknown();

//DP
//NR::ran1(int &idum)
void function(int idum)
{
  const int IA = 16807, IM = 2147483647, IQ = 127773, IR = 2836, NTAB = 32;
  const int NDIV = (1 + (IM - 1) / NTAB);
  //const //DP EPS = 3.0e-16, AM = 1.0 / IM, RNMX = (1.0 - EPS);
  static int iy = 0;

  // static Vec_INT iv(NTAB);
  int iv_dim1 = NTAB;
  
  int j, k;
  ////DP temp;

  if (idum <= 0 || iy == 0)
    {
      if (-idum < 1)
      	{
      	  idum = 1;
      	}
      else
      	{
      	  idum = -idum;
      	}
      for (j = NTAB + 7; j >= 0; j--)
	{
	  k = idum / IQ;
	  idum = IA * (idum - k * IQ) - IR * k;
	  if (idum < 0)
	    {
	      idum += IM;
	    }
	  if (j < NTAB)
	    {
	      ////iv[j] = idum;
	      //static_assert(0 <= j);
	      static_assert(j < iv_dim1);
	    }
	}
      //iy = iv[0];
      iy = unknown();
      //static_assert(0 <= 0);
      //static_assert(0 < iv_dim1);
    }
  k = idum / IQ;
  idum = IA * (idum - k * IQ) - IR * k;
  if (idum < 0)
    {
      idum += IM;
    }
  j = iy / NDIV;
  //iy = iv[j];
  iy = unknown();  
  //static_assert(0 <= j);
  //static_assert(j < iv_dim1);
  ////iv[j] = idum;
  //static_assert(0 <= j);
  //static_assert(j < iv_dim1);
  //if ((temp = AM * iy) > RNMX)
  // {
  //   return RNMX;
  // }
  // else
  // {
  //   return temp;
  // }
}


