// Numerical Recipes in C++, 2nd edition, pg. 285

int assume(bool);
int static_assert(bool);
int unknown();

//DP
//NR::ran2(int &idum)
void function(int idum)
{
  const int IM1 = 2147483563, IM2 = 2147483399;
  const int IA1 = 40014, IA2 = 40692, IQ1 = 53668, IQ2 = 52774;
  const int IR1 = 12211, IR2 = 3791, NTAB = 32, IMM1 = IM1 - 1;
  const int NDIV = 1 + IMM1 / NTAB;
  //const //DP EPS = 3.0e-16, RNMX = 1.0 - EPS, AM = 1.0 / //DP(IM1);
  static int idum2 = 123456789, iy = 0;
  // static Vec_INT iv(NTAB);
  int iv_dim1 = NTAB;
  int j, k;
  ////DP temp;

  if (idum <= 0)
    {
      // idum = (idum == 0 ? 1 : -idum);
      if (idum == 0) idum = 1;
      else           idum = -idum;
      
      idum2 = idum;
      for (j = NTAB + 7; j >= 0; j--)
	{
	  k = idum / IQ1;
	  idum = IA1 * (idum - k * IQ1) - k * IR1;
	  if (idum < 0)
	    {
	      idum += IM1;
	    }
	  if (j < NTAB)
	    {
	      ////iv[j] = idum;
	      //static_assert(0 <= j);
	      //static_assert(j < iv_dim1);
	    }
	}
      //iy = iv[0];
      iy = unknown();
      static_assert(0 <= 0);
      //static_assert(0 < iv_dim1);
    }
  k = idum / IQ1;
  idum = IA1 * (idum - k * IQ1) - k * IR1;
  if (idum < 0)
    {
      idum += IM1;
    }
  k = idum2 / IQ2;
  idum2 = IA2 * (idum2 - k * IQ2) - k * IR2;
  if (idum2 < 0)
    {
      idum2 += IM2;
    }
  j = iy / NDIV;
  //iy = iv[j] - idum2;
  iy = unknown();  
  //static_assert(0 <= j);
  //static_assert(j < iv_dim1);
  ////iv[j] = idum;
  //static_assert(0 <= j);
  //static_assert(j < iv_dim1);
  // if (iy < 1)
  //   {
  //     iy += IMM1;
  //   }
  // if ((temp = AM * iy) > RNMX)
  // {
  //   return RNMX;
  // }
  // else
  // {
  //   return temp;
  // }
}
