// Numerical Recipes in C++, 2nd edition, pg. 211

int assume(bool);
int static_assert(bool);
int unknown();

void
////NR::ratlsq(DP fn(const DP), const DP a, const DP b, const int mm,
function(const int mm, const int kk)
     //const int kk, Vec_O_DP & cof, DP & dev)
{
  assume(mm > 0);
  assume(kk > 0);

  const int NPFAC = 8, MAXIT = 5;
  //const DP BIG = 1.0e30, PIO2 = 1.570796326794896619;
  int i, it, j, ncof, npt;
  //DP devmax, e, hth, power, sum;
  
  assume(ncof > 0);
  
  ncof = mm + kk + 1;
  npt = NPFAC * ncof;

  int cof_dim1 = ncof;
  
  //Vec_DP bb(npt), coff(ncof), ee(npt), fs(npt), w(ncof), wt(npt), xs(npt);
  int   bb_dim1 = npt;
  int coff_dim1 = ncof;
  int   ee_dim1 = npt;
  int   fs_dim1 = npt;
  int    w_dim1 = ncof;
  int   wt_dim1 = npt;
  int   xs_dim1 = npt;
  
  //Mat_DP u(npt, ncof), v(ncof, ncof);
  int u_dim1 = npt;
  int u_dim2 = ncof;
  int v_dim1 = ncof;
  int v_dim2 = ncof;

  // dev = BIG;
  for (i = 0; i < npt; i++)
    {
      if (i < (npt / 2) - 1)
	{
	  //hth = PIO2 * i / (npt - 1.0);
	  //xs[i] = a + (b - a) * SQR(sin(hth));
	  //static_assert(0 <= i);
	  //static_assert(i < xs_dim1);
	}
      else
	{
	  //hth = PIO2 * (npt - i) / (npt - 1.0);
	  //xs[i] = b - (b - a) * SQR(sin(hth));
	  //static_assert(0 <= i);
	  //static_assert(i < xs_dim1);
	}
      //fs[i] = fn(xs[i]);
      //static_assert(0 <= i);
      //static_assert(i < fs_dim1);
      //static_assert(0 <= i);
      //static_assert(i < xs_dim1);
      //wt[i] = 1.0;
      //static_assert(0 <= i);
      //static_assert(i < wt_dim1);
      //ee[i] = 1.0;
      //static_assert(0 <= i);
      //static_assert(i < ee_dim1);
    }
  // e = 0.0;
  for (it = 0; it < MAXIT; it++)
    {
      for (i = 0; i < npt; i++)
	{
	  //power = wt[i];
	  //static_assert(0 <= i);
	  //static_assert(i < wt_dim1);
	  //bb[i] = power * (fs[i] + SIGN(e, ee[i]));
	  //static_assert(0 <= i);
	  //static_assert(i < bb_dim1);
	  //static_assert(0 <= i);
	  //static_assert(i < fs_dim1);
	  //static_assert(0 <= i);
	  //static_assert(i < ee_dim1);
	  for (j = 0; j < mm + 1; j++)
	    {
	      //u[i][j] = power;
	      //static_assert(0 <= i);
	      //static_assert(i < u_dim1);
	      //static_assert(0 <= j);
	      //static_assert(j < u_dim2);
	      //power *= xs[i];
	      //static_assert(0 <= i);
	      //static_assert(i < xs_dim1);
	    }
	  //power = -bb[i];
	  //static_assert(0 <= i);
	  //static_assert(i < bb_dim1);
	  for (j = mm + 1; j < ncof; j++)
	    {
	      //power *= xs[i];
	      //static_assert(0 <= i);
	      //static_assert(i < xs_dim1);
	      //u[i][j] = power;
	      //static_assert(0 <= i);
	      //static_assert(i < u_dim1);
	      //static_assert(0 <= j);
	      //static_assert(j < u_dim2);
	    }
	}
      // svdcmp(u, w, v);
      // svbksb(u, w, v, bb, coff);
      // devmax = sum = 0.0;
      for (j = 0; j < npt; j++)
	{
	  //ee[j] = ratval(xs[j], coff, mm, kk) - fs[j];
	  //static_assert(0 <= j);
	  //static_assert(j < ee_dim1);
	  //static_assert(0 <= j);
	  //static_assert(j < xs_dim1);
	  //static_assert(0 <= j);
	  //static_assert(j < fs_dim1);
	  //wt[j] = fabs(ee[j]);
	  //static_assert(0 <= j);
	  static_assert(j < wt_dim1);
	  //static_assert(0 <= j);
	  //static_assert(j < ee_dim1);
	  //sum += wt[j];
	  //static_assert(0 <= j);
	  //static_assert(j < wt_dim1);

	  //static_assert(0 <= j);
	  //static_assert(j < wt_dim1);
	  if (unknown() /*wt[j] > devmax*/)
	  {
	    //devmax = wt[j];
	    //static_assert(0 <= j);
	    //static_assert(j < wt_dim1);
	  }
	}
      // e = sum / npt;
      if (unknown() /*devmax <= dev*/)
	{
	  for (j = 0; j < ncof; j++)
	    {
	      //cof[j] = coff[j];
	      //static_assert(0 <= j);
	      //static_assert(j < cof_dim1);
	      //static_assert(0 <= j);
	      //static_assert(j < coff_dim1);
	    }
	  // dev = devmax;
	}
      // cout << " ratlsq iteration= " << it;
      // cout << "  max error= " << setw(10) << devmax << endl;
    }
}
