// Numerical Recipes in C++, 2nd edition, pg. 883

int assume(bool);
int static_assert(bool);
int unknown();

void
////NR::relax(Mat_IO_DP & u, Mat_I_DP & rhs)
function()
{

  int rhs_dim1;
  int rhs_dim2;
  int   u_dim1;
  int   u_dim2;

  assume(u_dim1 > 1);
  assume(rhs_dim1 == u_dim1);
  assume(rhs_dim2 == u_dim1);  
  assume(  u_dim2 == u_dim1);
  
  int i, ipass, isw, j, jsw = 1;
  //DP h, h2;

  int n = u_dim1;
  // h = 1.0 / (n - 1);
  // h2 = h * h;
  for (ipass = 0; ipass < 2; ipass++, jsw = 3 - jsw) {
    isw = jsw;
    for (j = 1; j < n - 1; j++, isw = 3 - isw) {
      for (i = isw; i < n - 1; i += 2) {
	//u[i][j] =
	//0.25 * (u[i + 1][j] + u[i - 1][j] +
	//u[i][j + 1]
	//+u[i][j - 1] - h2 * rhs[i][j]);
	static_assert(0 <= i);
	//static_assert(i < u_dim1);
	//static_assert(0 <= j);
	//static_assert(j < u_dim2);
	//static_assert(0 <= i + 1);
	//static_assert(i + 1 < u_dim1);
	//static_assert(0 <= j);
	//static_assert(j < u_dim2);
	//static_assert(0 <= i - 1);
	//static_assert(i - 1 < u_dim1);
	//static_assert(0 <= j);
	//static_assert(j < u_dim2);
	//static_assert(0 <= i);
	//static_assert(i < u_dim1);
	//static_assert(0 <= j + 1);
	//static_assert(j + 1 < u_dim2);
	//static_assert(0 <= i);
	//static_assert(i < u_dim1);
	//static_assert(0 <= j - 1);
	//static_assert(j - 1 < u_dim2);
	//static_assert(0 <= i);
	//static_assert(i < rhs_dim1);
	//static_assert(0 <= j);
	//static_assert(j < rhs_dim2);
      }
    }
  }
}
