// Numerical Recipes in C++, 2nd edition, pg. 657

#include <cmath>
int assume(bool);
int static_assert(bool);
int unknown();
using namespace std;

void
////NR::savgol(Vec_O_DP & c, const int np, const int nl, const int nr,
//     const int ld, const int m)
function(const int np, const int nl, const int nr, const int ld, const int m)
{
  int j, k, imj, ipj, kk, mm;
  //DP d, fac, sum;

  int c_dim1 = np;
  
  // if (np < nl + nr + 1 || nl < 0 || nr < 0 || ld > m || nl + nr < m)
  //   {
  //     nrerror("bad args in savgol");
  //   }
  assume(np >= nl + nr + 1);
  assume(nl >= 0);
  assume(nr >= 0);
  assume(ld <= m);
  assume(ld >= 0);  
  assume(nl + nr >= m);

  // Vec_INT indx(m + 1);

  //Mat_DP a(m + 1, m + 1);
  //Vec_DP b(m + 1);
  int a_dim1 = m+1;
  int a_dim2 = m+1;       
  int b_dim1 = m+1;
       
  for (ipj = 0; ipj <= 2*m; ipj++)
    {
      // sum = (ipj ? 0.0 : 1.0);
      for (k = 1; k <= nr; k++)
	{
	  //sum += pow(DP(k), DP(ipj));
	}
      for (k = 1; k <= nl; k++)
	{
	  //sum += pow(DP(-k), DP(ipj));
	}
      // mm = MIN(ipj, 2 * m - ipj);
      if (ipj < 2 * m - ipj) mm = ipj;
      else                   mm = 2*m - ipj;

      for (imj = -mm; imj <= mm; imj += 2)
	{
	  //a[(ipj + imj) / 2][(ipj - imj) / 2] = sum;
	  static_assert(0 <= (ipj + imj) / 2);
	  //static_assert((ipj + imj) / 2 < a_dim1);
	  //static_assert(0 <= (ipj - imj) / 2);
	  //static_assert((ipj - imj) / 2 < a_dim2);
	}
    }
  // ludcmp(a, indx, d);
  for (j = 0; j < m + 1; j++)
    {
      //b[j] = 0.0;
      //static_assert(0 <= j);
      //static_assert(j < b_dim1);
    }
  //b[ld] = 1.0;
  //static_assert(0 <= ld);
  //static_assert(ld < b_dim1);
  // lubksb(a, indx, b);
  for (kk = 0; kk < np; kk++)
    {
      //c[kk] = 0.0;
      //static_assert(0 <= kk);
      //static_assert(kk < c_dim1);
    }
  for (k = -nl; k <= nr; k++)
    {
      //sum = b[0];
      //static_assert(0 <= 0);
      //static_assert(0 < b_dim1);
      // fac = 1.0;
      for (mm = 1; mm <= m; mm++)
	{
	  //sum += b[mm] * (fac *= k);
	  //static_assert(0 <= mm);
	  //static_assert(mm < b_dim1);
	}
      // kk = (np - k) % np;
      assume(kk >= 0);
      assume(kk < np);
      //c[kk] = sum;
      //static_assert(0 <= kk);
      //static_assert(kk < c_dim1);
    }
}
