// Numerical Recipes in C++, 2nd edition, pg. 446

int assume(bool);
int static_assert(bool);
int unknown();

void
////NR::simp2(Mat_I_DP & a, const int m, const int n, int &ip, const int kp)
function(const int m, const int n, int ip, const int kp)
{
  assume(m > 0);
  assume(n > 0);
  assume(kp >= 0);
  assume(kp <= n);
  
  int a_dim1 = m+2;
  int a_dim2 = n+1;

  //const DP EPS = 1.0e-14;
  int k, i;
  //DP qp, q0, q, q1;

  ip = 0;
  for (i = 0; i < m; i++) {
    //static_assert(0 <= i + 1);
    //static_assert(i + 1 < a_dim1);
    //static_assert(0 <= kp);
    //static_assert(kp < a_dim2);
    if (unknown() /*a[i + 1][kp] < -EPS*/) {
      {
	break;
      }
    }
  }
  if (i + 1 > m)
    {
      return;
    }

  //q1 = -a[i + 1][0] / a[i + 1][kp];
  //static_assert(0 <= i + 1);
  //static_assert(i + 1 < a_dim1);
  //static_assert(0 <= 0);
  //static_assert(0 < a_dim2);
  //static_assert(0 <= i + 1);
  //static_assert(i + 1 < a_dim1);
  //static_assert(0 <= kp);
  //static_assert(kp < a_dim2);

  ip = i + 1;
  for (i = ip; i < m; i++)
    {
      //static_assert(0 <= i + 1);
      //static_assert(i + 1 < a_dim1);
      //static_assert(0 <= kp);
      //static_assert(kp < a_dim2);
      if (unknown()/*a[i + 1][kp] < -EPS*/)
	{
	  //q = -a[i + 1][0] / a[i + 1][kp];
	  //static_assert(0 <= i + 1);
	  static_assert(i + 1 < a_dim1);
	  //static_assert(0 <= 0);
	  //static_assert(0 < a_dim2);
	  //static_assert(0 <= i + 1);
	  //static_assert(i + 1 < a_dim1);
	  //static_assert(0 <= kp);
	  //static_assert(kp < a_dim2);
	  if (unknown()/*q < q1*/)
	    {
	      ip = i + 1;
	      // q1 = q;
	    }
	  else if (unknown()/*q == q1*/)
	    {
	      for (k = 0; k < n; k++)
		{
		  //qp = -a[ip][k + 1] / a[ip][kp];
		  //static_assert(0 <= ip);
		  //static_assert(ip < a_dim1);
		  //static_assert(0 <= k + 1);
		  //static_assert(k + 1 < a_dim2);
		  //static_assert(0 <= ip);
		  //static_assert(ip < a_dim1);
		  //static_assert(0 <= kp);
		  //static_assert(kp < a_dim2);
		  //q0 = -a[i][k + 1] / a[i][kp];
		  //static_assert(0 <= i);
		  //static_assert(i < a_dim1);
		  //static_assert(0 <= k + 1);
		  //static_assert(k + 1 < a_dim2);
		  //static_assert(0 <= i);
		  //static_assert(i < a_dim1);
		  //static_assert(0 <= kp);
		  //static_assert(kp < a_dim2);
		  if (unknown() /*q0 != qp*/)
		    {
		      break;
		    }
		}
	      if (unknown()/*q0 < qp*/)
		{
		  ip = i + 1;
		}
	    }
	}
    }
}
