// Numerical Recipes in C++, 2nd edition, pg. 871

#include <cmath>
int assume(bool);
int static_assert(bool);
int unknown();
using namespace std;

void
////NR::sor(Mat_I_DP & a, Mat_I_DP & b, Mat_I_DP & c, Mat_I_DP & d, Mat_I_DP & e,
function()
//Mat_I_DP & f, Mat_IO_DP & u, const DP rjac)
{
  int a_dim1;
  assume(a_dim1 > 0);
  int a_dim2;
  assume(a_dim2 == a_dim1);
  int b_dim1;
  assume(b_dim1 == a_dim1);
  int b_dim2;
  assume(b_dim2 == a_dim1);
  int c_dim1;
  assume(c_dim1 == a_dim1);
  int c_dim2;
  assume(c_dim2 == a_dim1);
  int d_dim1;
  assume(d_dim1 == a_dim1);
  int d_dim2;
  assume(d_dim2 == a_dim1);
  int e_dim1;
  assume(e_dim1 == a_dim1);
  int e_dim2;
  assume(e_dim2 == a_dim1);
  int f_dim1;
  assume(f_dim1 == a_dim1);
  int f_dim2;
  assume(f_dim2 == a_dim1);
  int u_dim1;
  assume(u_dim1 == a_dim1);
  int u_dim2;
  assume(u_dim2 == a_dim1);

  const int MAXITS = 1000;
  //const DP EPS = 1.0e-13;
  int j, l, n, ipass, jsw, lsw;
  //DP anorm, anormf = 0.0, omega = 1.0, resid;
  
  int jmax = a_dim1;
  for (j = 1; j < jmax - 1; j++)
    for (l = 1; l < jmax - 1; l++)
      {
	//anormf += fabs(f[j][l]);
	//static_assert(0 <= j);
	//static_assert(j < f_dim1);
	//static_assert(0 <= l);
	//static_assert(l < f_dim2);
      }
  for (n = 0; n < MAXITS; n++)
    {
      // anorm = 0.0;
      jsw = 1;
      for (ipass = 0; ipass < 2; ipass++)
	{
	  lsw = jsw;
	  for (j = 1; j < jmax - 1; j++)
	    {
	      for (l = lsw; l < jmax - 1; l += 2)
		{
		  // resid = a[j][l] * u[j + 1][l] + b[j][l] * u[j - 1][l]
		  //static_assert(0 <= j);
		  //static_assert(j < a_dim1);
		  static_assert(0 <= l);
		  //static_assert(l < a_dim2);
		  //static_assert(0 <= j + 1);
		  //static_assert(j + 1 < u_dim1);
		  //static_assert(0 <= l);
		  //static_assert(l < u_dim2);
		  //static_assert(0 <= j);
		  //static_assert(j < b_dim1);
		  //static_assert(0 <= l);
		  //static_assert(l < b_dim2);
		  //static_assert(0 <= j - 1);
		  //static_assert(j - 1 < u_dim1);
		  //static_assert(0 <= l);
		  //static_assert(l < u_dim2);
		  //+c[j][l] * u[j][l + 1] + d[j][l] * u[j][l - 1]
		  //+e[j][l] * u[j][l] - f[j][l];				      
		  //static_assert(0 <= j);
		  //static_assert(j < c_dim1);
		  //static_assert(0 <= l);
		  //static_assert(l < c_dim2);
		  //static_assert(0 <= j);
		  //static_assert(j < u_dim1);
		  //static_assert(0 <= l + 1);
		  //static_assert(l + 1 < u_dim2);
		  //static_assert(0 <= j);
		  //static_assert(j < d_dim1);
		  //static_assert(0 <= l);
		  //static_assert(l < d_dim2);
		  //static_assert(0 <= j);
		  //static_assert(j < u_dim1);
		  //static_assert(0 <= l - 1);
		  //static_assert(l - 1 < u_dim2);
		  //static_assert(0 <= j);
		  //static_assert(j < e_dim1);
		  //static_assert(0 <= l);
		  //static_assert(l < e_dim2);
		  //static_assert(0 <= j);
		  //static_assert(j < u_dim1);
		  //static_assert(0 <= l);
		  //static_assert(l < u_dim2);
		  //static_assert(0 <= j);
		  //static_assert(j < f_dim1);
		  //static_assert(0 <= l);
		  //static_assert(l < f_dim2);
		  // anorm += fabs(resid);
		  //u[j][l] -= omega * resid / e[j][l];
		  //static_assert(0 <= j);
		  //static_assert(j < u_dim1);
		  //static_assert(0 <= l);
		  //static_assert(l < u_dim2);
		  //static_assert(0 <= j);
		  //static_assert(j < e_dim1);
		  //static_assert(0 <= l);
		  //static_assert(l < e_dim2);
		}
	      lsw = 3 - lsw;
	    }
	  jsw = 3 - jsw;
	  // omega = (n == 0 && ipass ==
	  // 	   //0 ? 1.0 / (1.0 - 0.5 * rjac * rjac) : 1.0 / (1.0 -
	  // 	   0.25 * rjac * rjac * omega));
    }
  if (unknown()/*anorm < EPS * anormf*/)
    {
      return;
    }
}
// nrerror("MAXITS exceeded");
}
