// Numerical Recipes in C++, 2nd edition, pg. 738

int assume(bool);
int static_assert(bool);
int unknown();

void
////NR::stoerm(Vec_I_DP & y, Vec_I_DP & d2y, const DP xs,
function(int nstep)
     //const DP htot, const int nstep, Vec_O_DP & yout,
       //void derivs(const DP, Vec_I_DP &, Vec_O_DP &))
{
  int y_dim1;
  assume(y_dim1 > 0);
  int yout_dim1;
  assume(yout_dim1 == y_dim1);
  int d2y_dim1;
  assume( d2y_dim1 == y_dim1);

  int i, nn, n, neqns;
  //DP h, h2, halfh, x;

  int nv = y_dim1;
  //Vec_DP ytemp(nv);
  int ytemp_dim1;

  // h = htot / nstep;
  //halfh = 0.5 * h;
  neqns = nv / 2;
  for (i = 0; i < neqns; i++)
    {
      n = neqns + i;
      //ytemp[i] = y[i] + (ytemp[n] = h * (y[n] + halfh * d2y[i]));
      //static_assert(0 <= i);
      //static_assert(i < ytemp_dim1);
      //static_assert(0 <= i);
      //static_assert(i < y_dim1);
      //static_assert(0 <= n);
      //static_assert(n < ytemp_dim1);
      //static_assert(0 <= n);
      //static_assert(n < y_dim1);
      //static_assert(0 <= i);
      //static_assert(i < d2y_dim1);
    }
  // x = xs + h;
  // derivs(x, ytemp, yout);
  //h2 = h * h;
  for (nn = 1; nn < nstep; nn++)
    {
      for (i = 0; i < neqns; i++)
	{
	  //ytemp[i] += (ytemp[neqns + i] += h2 * yout[i]);
	  //static_assert(0 <= i);
	  static_assert(i < ytemp_dim1);
	  //static_assert(0 <= neqns + i);
	  //static_assert(neqns + i < ytemp_dim1);
	  //static_assert(0 <= i);
	  //static_assert(i < yout_dim1);
	}
      // x += h;
      // derivs(x, ytemp, yout);
    }
  for (i = 0; i < neqns; i++)
    {
      n = neqns + i;
      //yout[n] = ytemp[n] / h + halfh * yout[i];
      //static_assert(0 <= n);
      //static_assert(n < yout_dim1);
      //static_assert(0 <= n);
      //static_assert(n < ytemp_dim1);
      //static_assert(0 <= i);
      //static_assert(i < yout_dim1);
      //yout[i] = ytemp[i];
      //static_assert(0 <= i);
      //static_assert(i < yout_dim1);
      //static_assert(0 <= i);
      //static_assert(i < ytemp_dim1);
    }
}
