// Numerical Recipes in C++, 2nd edition, pg. 70

int static_assert(bool);
int unknown();
int assume(bool);

void function() {

  int a_row_dim, a_col_dim;
  assume(a_row_dim >= 0);
  assume(a_col_dim >= 0);

  int w_dim;
  assume(w_dim >= 0);

  int v_row_dim, v_col_dim;
  assume(v_row_dim >= 0);
  assume(v_col_dim >= 0);

  assume(    w_dim == a_col_dim);

  assume(v_col_dim == a_col_dim);
  assume(v_row_dim == a_col_dim);

  int flag;
  int i,its,j,jj,k,l,nm;

  // int m=a.nrows();
  // int n=a.ncols();
  int m = a_row_dim;
  int n = a_col_dim;

  // Vec_DP rv1(n);
  int rv1_dim = n;

  for (i=0;i<n;i++) {
    l=i+2;

    // rv1[i]=scale*g;
    //static_assert(i >= 0);
    //static_assert(i < rv1_dim);

    if (i < m) {
      for (k=i;k<m;k++) {
	// scale += fabs(a[k][i]);
	//static_assert(k >= 0);
	//static_assert(k < a_row_dim);
	//static_assert(i >= 0);
	//static_assert(i < a_col_dim);
      }
      if (unknown()) {
	for (k=i;k<m;k++) {
	  // a[k][i] /= scale;
	  // s += a[k][i]*a[k][i];
	  //static_assert(k >= 0);
	  //static_assert(k < a_row_dim);
	  //static_assert(i >= 0);
	  //static_assert(i < a_col_dim);
	}

	// f=a[i][i];
	// a[i][i]=f-g;
	//static_assert(i >= 0);
	//static_assert(i < a_col_dim);
	//static_assert(i >= 0);
	//static_assert(i < a_row_dim);

	for (j=l-1;j<n;j++) {
	  for (k=i;k<m;k++) {
	    // s += a[k][i]*a[k][j];
	    //static_assert(k >= 0);
	    //static_assert(k < a_row_dim);
	    //static_assert(i >= 0);
	    //static_assert(i < a_col_dim);
	    //static_assert(j >= 0);
	    //static_assert(j < a_col_dim);
	  }
	  for (k=i;k<m;k++) {
	    // a[k][j] += f*a[k][i];
	    //static_assert(k >= 0);
	    //static_assert(k < a_row_dim);
	    static_assert(i >= 0);
	    //static_assert(i < a_col_dim);
	    //static_assert(j >= 0);
	    //static_assert(j < a_col_dim);
	  }
	}
	for (k=i;k<m;k++) {
	  // a[k][i] *= scale;
	  //static_assert(k >= 0);
	  //static_assert(k < a_row_dim);
	  //static_assert(i >= 0);
	  //static_assert(i < a_col_dim);
	}
      }
    }

    // w[i]=scale *g;
    //static_assert(i >= 0);
    //static_assert(i < w_dim);

    if (i+1 <= m ) {
      if (i+1 != n) {  // There was a bug (typo?) in the original code we had
	for (k=l-1;k<n;k++) {
	  // scale += fabs(a[i][k]);
	  //static_assert(i >= 0);
	  //static_assert(i < a_row_dim);
	  //static_assert(k >= 0);
	  //static_assert(k < a_col_dim);
	}
	if (unknown()) {
	  for (k=l-1;k<n;k++) {
	    // a[i][k] /= scale;
	    // s += a[i][k]*a[i][k];
	    //static_assert(i >= 0);
	    //static_assert(i < a_row_dim);
	    //static_assert(k >= 0);
	    //static_assert(k < a_col_dim);
	  }
	  // f=a[i][l-1];
	  // a[i][l-1]=f-g;
	  //static_assert(i >= 0);
	  //static_assert(i < a_row_dim);
	  //static_assert(l-1 >= 0);
	  //static_assert(l-1 < a_col_dim);

	  for (k=l-1;k<n;k++) {
	    // rv1[k]=a[i][k]/h;
	    //static_assert(k >= 0);
	    //static_assert(k < rv1_dim);
	    //static_assert(i >= 0);
	    //static_assert(i < a_row_dim);
	    //static_assert(k >= 0);
	    //static_assert(k < a_col_dim);
	  }
	  for (j=l-1;j<m;j++) {
	    for (k=l-1;k<n;k++) {
	      // s += a[j][k]*a[i][k];
	      //static_assert(j >= 0);
	      //static_assert(j < a_row_dim);
	      //static_assert(i >= 0);
	      //static_assert(i < a_row_dim);
	      //static_assert(k >= 0);
	      //static_assert(k < a_col_dim);
	    }
	    for (k=l-1;k<n;k++) {
	      // a[j][k] += s*rv1[k];
	      //static_assert(j >= 0);
	      //static_assert(j < a_row_dim);
	      //static_assert(k >= 0);
	      //static_assert(k < a_col_dim);
	      //static_assert(k >= 0);
	      //static_assert(k < rv1_dim);
	    }
	  }
	  for (k=l-1;k<n;k++) {
	    // a[i][k] *= scale;
	    //static_assert(i >= 0);
	    //static_assert(i < a_row_dim);
	    //static_assert(k >= 0);
	    //static_assert(k < a_col_dim);
	  }
	}
      }
    }
    // anorm=MAX(anorm,(fabs(w[i])+fabs(rv1[i])));
    //static_assert(i >= 0);
    //static_assert(i < w_dim);
    //static_assert(i >= 0);
    //static_assert(i < rv1_dim);
  }

  for (i=n-1;i>=0;i--) {
    if (i < n-1) {
      if (unknown()) {
	for (j=l;j<n;j++) {

	  // v[j][i]=(a[i][j]/a[i][l])/g;
	  
	  //static_assert(j >= 0);
	  //static_assert(j < v_row_dim);
	  //static_assert(i >= 0);
	  //static_assert(i < v_col_dim);

	  //static_assert(i >= 0);
	  //static_assert(i < a_row_dim);
	  //static_assert(j >= 0);
	  //static_assert(j < a_col_dim);

	  //static_assert(i >= 0);
	  //static_assert(i < a_row_dim);
	  //static_assert(l >= 0);
	  //static_assert(l < a_col_dim);
	}
	for (j=l;j<n;j++) {
	  for (k=l;k<n;k++) {

	    // s += a[i][k]*v[k][j];
	    
	    //static_assert(i >= 0);
	    //static_assert(i < a_row_dim);
	    //static_assert(k >= 0);
	    //static_assert(k < a_col_dim);

	    //static_assert(k >= 0);
	    //static_assert(k < v_row_dim);
	    //static_assert(j >= 0);
	    //static_assert(j < v_col_dim);
	  }
	  for (k=l;k<n;k++) {
	    // v[k][j] += s*v[k][i];
	    //static_assert(k >= 0);
	    //static_assert(k < v_row_dim);
	    //static_assert(j >= 0);
	    //static_assert(j < v_col_dim);

	    //static_assert(k >= 0);
	    //static_assert(k < v_row_dim);
	    //static_assert(i >= 0);
	    //static_assert(i < v_col_dim);
	  }
	}
      }
      for (j=l;j<n;j++) {
	// v[i][j]=v[j][i]=0.0;
	//static_assert(i >= 0);
	//static_assert(i < v_row_dim);
	//static_assert(j >= 0);
	//static_assert(j < v_col_dim);

	//static_assert(j >= 0);
	//static_assert(j < v_row_dim);
	//static_assert(i >= 0);
	//static_assert(i < v_col_dim);
      }
    }
    // v[i][i]=1.0;
    //static_assert(i >= 0);
    //static_assert(i < v_row_dim);
    //static_assert(i >= 0);
    //static_assert(i < v_col_dim);

    // g=rv1[i];
    //static_assert(i >= 0);
    //static_assert(i < rv1_dim);

    l=i;
  }

  int min;
  if (m < n) min = m;
  else       min = n;
  
  for (i=min-1;i>=0;i--) {
    l=i+1;

    // g=w[i];
    //static_assert(i >= 0);
    //static_assert(i < w_dim);

    for (j=l;j<n;j++) {
      // a[i][j]=0.0;
      //static_assert(i >= 0);
      //static_assert(i < a_row_dim);
      //static_assert(j >= 0);
      //static_assert(j < a_col_dim);
    }
      
    if (unknown()) {
      for (j=l;j<n;j++) {
	for (k=l;k<m;k++) {
	  // s += a[k][i]*a[k][j];
	  //static_assert(k >= 0);
	  //static_assert(k < a_row_dim);
	  //static_assert(i >= 0);
	  //static_assert(i < a_col_dim);
	  //static_assert(j >= 0);
	  //static_assert(j < a_col_dim);
	}
	// f=(s/a[i][i])*g;
	//static_assert(i >= 0);
	//static_assert(i < a_row_dim);
	//static_assert(i >= 0);
	//static_assert(i < a_col_dim);

	for (k=i;k<m;k++) {
	  // a[k][j] += f*a[k][i];
	  //static_assert(k >= 0);
	  //static_assert(k < a_row_dim);
	  //static_assert(j >= 0);
	  //static_assert(j < a_col_dim);
	  //static_assert(i >= 0);
	  //static_assert(i < a_col_dim);
	}
      }
      for (j=i;j<m;j++) {
	// a[j][i] *= g;
	//static_assert(j >= 0);
	//static_assert(j < a_row_dim);
	//static_assert(i >= 0);
	//static_assert(i < a_col_dim);
      }
    } else for (j=i;j<m;j++) {
	// a[j][i]=0.0;
	//static_assert(j >= 0);
	//static_assert(j < a_row_dim);
	//static_assert(i >= 0);
	//static_assert(i < a_col_dim);
      }

    // ++a[i][i];
    //static_assert(i >= 0);
    //static_assert(i < a_row_dim);
    //static_assert(i >= 0);
    //static_assert(i < a_col_dim);
  }
  for (k=n-1;k>=0;k--) {
    for (its=0;its<30;its++) {
      flag=1;
      for (l=k;l>=0;l--) {
	nm=l-1;
	if (unknown()) {
	  flag=0;
	  break;
	}
	if (unknown()) break;
      }
      if (flag >= 1) {
	for (i=l-1;i<k+1;i++) {

	  // f=s*rv1[i];
	  // rv1[i]=c*rv1[i];
	  //static_assert(i >= 0);
	  //static_assert(i < rv1_dim);

	  if (unknown()) break;

	  // g=w[i];
	  // w[i]=h;
	  //static_assert(i >= 0);
	  //static_assert(i < w_dim);

	  for (j=0;j<m;j++) {

	    // y=a[j][nm];
	    // z=a[j][i];
	    // a[j][nm]=y*c+z*s;
	    // a[j][i]=z*c-y*s;
	    //static_assert(j >= 0);
	    //static_assert(j < a_row_dim);
	    //static_assert(nm >= 0);
	    //static_assert(nm < a_col_dim);
	    //static_assert(i >= 0);
	    //static_assert(i < a_col_dim);
	  }
	}
      }
      // z=w[k];
      //static_assert(k >= 0);
      //static_assert(k < w_dim);
      
      if (l == k) {
	if (unknown()) {

	  // w[k] = -z;
	  //static_assert(k >= 0);
	  //static_assert(k < w_dim);

	  for (j=0;j<n;j++) {
	    // v[j][k] = -v[j][k];
	    //static_assert(j >= 0);
	    //static_assert(j < v_row_dim);
	    //static_assert(k >= 0);
	    //static_assert(k < v_col_dim);
	  }
	}
	break;
      }
      if (its == 29) { ; }
      
      // x=w[l];
      //static_assert(l >= 0);
      //static_assert(l < w_dim);

      nm=k-1;
      // y=w[nm];
      //static_assert(nm >= 0);
      //static_assert(nm < w_dim);

      // g=rv1[nm];
      //static_assert(nm >= 0);
      //static_assert(nm < rv1_dim);

      // h=rv1[k];
      //static_assert(k >= 0);
      //static_assert(k < rv1_dim);

      for (j=l;j<=nm;j++) {
	i=j+1;

	// g=rv1[i];
	//static_assert(i >= 0);
	//static_assert(i < rv1_dim);

	// y=w[i];
	//static_assert(i >= 0);
	//static_assert(i < w_dim);

	// rv1[j]=z;
	//static_assert(j >= 0);
	//static_assert(j < rv1_dim);

	for (jj=0;jj<n;jj++) {

	  // x=v[jj][j];
	  // z=v[jj][i];
	  // v[jj][j]=x*c+z*s;
	  // v[jj][i]=z*c-x*s;

	  //static_assert(jj >= 0);
	  //static_assert(jj < v_row_dim);
	  //static_assert(j >= 0);
	  //static_assert(j < v_col_dim);
	  //static_assert(i >= 0);
	  //static_assert(i < v_col_dim);
	}

	// w[j]=z;
	//static_assert(j >= 0);
	//static_assert(j < w_dim);

	if (unknown()) {
	  ;
	}
	
	for (jj=0;jj<m;jj++) {
	  // y=a[jj][j];
	  // z=a[jj][i];
	  // a[jj][j]=y*c+z*s;
	  // a[jj][i]=z*c-y*s;

	  //static_assert(jj >= 0);
	  //static_assert(jj < v_row_dim);
	  //static_assert(j >= 0);
	  //static_assert(j < v_col_dim);
	  //static_assert(i >= 0);
	  //static_assert(i < v_col_dim);
	}
      }

      // rv1[l]=0.0;
      //static_assert(l >= 0);
      //static_assert(l < rv1_dim);
      
      // rv1[k]=f;
      //static_assert(k >= 0);
      //static_assert(k < rv1_dim);

      // w[k]=x;
      //static_assert(k >= 0);
      //static_assert(k < w_dim);
    }
  }
}
