// Numerical Recipes in C++, 2nd edition, pg. 485

#include <cmath>
int assume(bool);
int static_assert(bool);
int unknown();
using namespace std;

void
////NR::tqli(Vec_IO_DP & d, Vec_IO_DP & e, Mat_IO_DP & z)
function()
{

  int d_dim1;
  assume(d_dim1 > 0);
  int e_dim1;
  assume(e_dim1 == d_dim1);
  int z_dim1;
  assume(z_dim1 == d_dim1);
  int z_dim2;
  assume(z_dim2 == d_dim1);

  int m, l, iter, i, k;
  //DP s, r, p, g, f, dd, c, b;

  int n = d_dim1;
  for (i = 1; i < n; i++)
    {
      //e[i - 1] = e[i];
      //static_assert(0 <= i - 1);
      //static_assert(i - 1 < e_dim1);
      //static_assert(0 <= i);
      //static_assert(i < e_dim1);
    }
  //e[n - 1] = 0.0;
  //static_assert(0 <= n - 1);
  //static_assert(n - 1 < e_dim1);
  for (l = 0; l < n; l++)
    {
      iter = 0;
      do
	{
	  for (m = l; m < n - 1; m++)
	    {
	      //dd = fabs(d[m]) + fabs(d[m + 1]);
	      //static_assert(0 <= m);
	      //static_assert(m < d_dim1);
	      //static_assert(0 <= m + 1);
	      //static_assert(m + 1 < d_dim1);

	      //static_assert(0 <= m);
	      //static_assert(m < e_dim1);
	      if (unknown() /*fabs(e[m]) + dd == dd*/)
	      {
		break;
	      }
	    }
	  if (m != l)
	    {
	      if (iter == 30)
		{
		  // nrerror("Too many iterations in tqli");
		  return;
		}
	      iter++;
	      //g = (d[l + 1] - d[l]) / (2.0 * e[l]);
	      static_assert(0 <= l + 1);
	      //static_assert(l + 1 < d_dim1);
	      //static_assert(0 <= l);
	      //static_assert(l < d_dim1);
	      //static_assert(0 <= l);
	      //static_assert(l < e_dim1);
	      // r = pythag(g, 1.0);
	      //g = d[m] - d[l] + e[l] / (g + SIGN(r, g));
	      //static_assert(0 <= m);
	      //static_assert(m < d_dim1);
	      //static_assert(0 <= l);
	      //static_assert(l < d_dim1);
	      //static_assert(0 <= l);
	      //static_assert(l < e_dim1);
	      // s = c = 1.0;
	      // p = 0.0;
	      for (i = m - 1; i >= l; i--)
		{
		  //f = s * e[i];
		  //static_assert(0 <= i);
		  //static_assert(i < e_dim1);
		  //b = c * e[i];
		  //static_assert(0 <= i);
		  //static_assert(i < e_dim1);
		  //e[i + 1] = (r = pythag(f, g));
		  //static_assert(0 <= i + 1);
		  //static_assert(i + 1 < e_dim1);
		  if (unknown() /*r == 0.0*/)
		    {
		      //d[i + 1] -= p;
		      //static_assert(0 <= i + 1);
		      //static_assert(i + 1 < d_dim1);
		      ////e[m] = 0.0;
		      //static_assert(0 <= m);
		      //static_assert(m < e_dim1);
		      break;
		    }
		  // s = f / r;
		  // c = g / r;
		  //g = d[i + 1] - p;
		  //static_assert(0 <= i + 1);
		  //static_assert(i + 1 < d_dim1);
		  //r = (d[i] - g) * s + 2.0 * c * b;
		  //static_assert(0 <= i);
		  //static_assert(i < d_dim1);
		  //d[i + 1] = g + (p = s * r);
		  //static_assert(0 <= i + 1);
		  //static_assert(i + 1 < d_dim1);
		  //g = c * r - b;
		  // Next loop can be omitted if eigenvectors not wanted
		  for (k = 0; k < n; k++)
		    {
		      //f = z[k][i + 1];
		      //static_assert(0 <= k);
		      //static_assert(k < z_dim1);
		      //static_assert(0 <= i + 1);
		      //static_assert(i + 1 < z_dim2);
		      //z[k][i + 1] = s * z[k][i] + c * f;
		      //static_assert(0 <= k);
		      //static_assert(k < z_dim1);
		      //static_assert(0 <= i + 1);
		      //static_assert(i + 1 < z_dim2);
		      //static_assert(0 <= k);
		      //static_assert(k < z_dim1);
		      //static_assert(0 <= i);
		      //static_assert(i < z_dim2);
		      //z[k][i] = c * z[k][i] - s * f;
		      //static_assert(0 <= k);
		      //static_assert(k < z_dim1);
		      //static_assert(0 <= i);
		      //static_assert(i < z_dim2);
		      //static_assert(0 <= k);
		      //static_assert(k < z_dim1);
		      //static_assert(0 <= i);
		      //static_assert(i < z_dim2);
		    }
		}
	      if (unknown() /*r == 0.0*/)
		{
		  if (i >= l) continue;
		}
	      //d[l] -= p;
	      //static_assert(0 <= l);
	      //static_assert(l < d_dim1);
	      //e[l] = g;
	      //static_assert(0 <= l);
	      //static_assert(l < e_dim1);
	      ////e[m] = 0.0;
	      //static_assert(0 <= m);
	      //static_assert(m < e_dim1);
	    }
	}
      while (m != l);
    }
}
