// Numerical Recipes in C++, 2nd edition, pg. 479

#include <cmath>
int assume(bool);
int static_assert(bool);
int unknown();
using namespace std;

void
////NR::tred2(Mat_IO_DP & a, Vec_O_DP & d, Vec_O_DP & e)
function()
{

  int a_dim1;
  assume(a_dim1 > 0);
  int a_dim2;
  assume(a_dim2 == a_dim1);
  int d_dim1;
  assume(d_dim1 == a_dim1);
  int e_dim1;
  assume(e_dim1 == a_dim1);

  int l, k, j, i;
  //DP scale, hh, h, g, f;

  int n = d_dim1;
  for (i = n - 1; i > 0; i--)
    {
      l = i - 1;
      // h = scale = 0.0;
      if (l > 0)
	{
	  for (k = 0; k < l + 1; k++)
	    {
	      //scale += fabs(a[i][k]);
	      //static_assert(0 <= i);
	      //static_assert(i < a_dim1);
	      //static_assert(0 <= k);
	      //static_assert(k < a_dim2);
	    }
	  if (unknown() /*scale == 0.0*/)
	    {
	      ////e[i] = a[i][l];
	      //static_assert(0 <= i);
	      //static_assert(i < e_dim1);
	      //static_assert(0 <= i);
	      //static_assert(i < a_dim1);
	      //static_assert(0 <= l);
	      //static_assert(l < a_dim2);
	    }
	  else
	    {
	      for (k = 0; k < l + 1; k++)
		{
		  //a[i][k] /= scale;
		  //static_assert(0 <= i);
		  //static_assert(i < a_dim1);
		  //static_assert(0 <= k);
		  //static_assert(k < a_dim2);
		  //h += a[i][k] * a[i][k];
		  //static_assert(0 <= i);
		  //static_assert(i < a_dim1);
		  //static_assert(0 <= k);
		  //static_assert(k < a_dim2);
		  //static_assert(0 <= i);
		  //static_assert(i < a_dim1);
		  //static_assert(0 <= k);
		  //static_assert(k < a_dim2);
		}
	      //f = a[i][l];
	      //static_assert(0 <= i);
	      //static_assert(i < a_dim1);
	      //static_assert(0 <= l);
	      //static_assert(l < a_dim2);
	      // g = (f >= 0.0 ? -sqrt(h) : sqrt(h));
	      //e[i] = scale * g;
	      //static_assert(0 <= i);
	      //static_assert(i < e_dim1);
	      //h -= f * g;
	      //a[i][l] = f - g;
	      //static_assert(0 <= i);
	      //static_assert(i < a_dim1);
	      //static_assert(0 <= l);
	      //static_assert(l < a_dim2);
	      // f = 0.0;
	      for (j = 0; j < l + 1; j++)
		{
		  //a[j][i] = a[i][j] / h;
		  //static_assert(0 <= j);
		  //static_assert(j < a_dim1);
		  //static_assert(0 <= i);
		  //static_assert(i < a_dim2);
		  //static_assert(0 <= i);
		  //static_assert(i < a_dim1);
		  //static_assert(0 <= j);
		  //static_assert(j < a_dim2);
		  // g = 0.0;
		  for (k = 0; k < j + 1; k++)
		    {
		      //g += a[j][k] * a[i][k];
		      //static_assert(0 <= j);
		      //static_assert(j < a_dim1);
		      //static_assert(0 <= k);
		      //static_assert(k < a_dim2);
		      //static_assert(0 <= i);
		      //static_assert(i < a_dim1);
		      //static_assert(0 <= k);
		      //static_assert(k < a_dim2);
		    }
		  for (k = j + 1; k < l + 1; k++)
		    {
		      //g += a[k][j] * a[i][k];
		      //static_assert(0 <= k);
		      //static_assert(k < a_dim1);
		      //static_assert(0 <= j);
		      //static_assert(j < a_dim2);
		      //static_assert(0 <= i);
		      //static_assert(i < a_dim1);
		      //static_assert(0 <= k);
		      static_assert(k < a_dim2);
		    }
		  //e[j] = g / h;
		  //static_assert(0 <= j);
		  //static_assert(j < e_dim1);
		  //f += e[j] * a[i][j];
		  //static_assert(0 <= j);
		  //static_assert(j < e_dim1);
		  //static_assert(0 <= i);
		  //static_assert(i < a_dim1);
		  //static_assert(0 <= j);
		  //static_assert(j < a_dim2);
		}
	      // hh = f / (h + h);
	      for (j = 0; j < l + 1; j++)
		{
		  //f = a[i][j];
		  //static_assert(0 <= i);
		  //static_assert(i < a_dim1);
		  //static_assert(0 <= j);
		  //static_assert(j < a_dim2);
		  //e[j] = g = e[j] - hh * f;
		  //static_assert(0 <= j);
		  //static_assert(j < e_dim1);
		  //static_assert(0 <= j);
		  //static_assert(j < e_dim1);
		  for (k = 0; k < j + 1; k++)
		    {
		      //a[j][k] -= (f * e[k] + g * a[i][k]);
		      //static_assert(0 <= j);
		      //static_assert(j < a_dim1);
		      //static_assert(0 <= k);
		      //static_assert(k < a_dim2);
		      //static_assert(0 <= k);
		      //static_assert(k < e_dim1);
		      //static_assert(0 <= i);
		      //static_assert(i < a_dim1);
		      //static_assert(0 <= k);
		      //static_assert(k < a_dim2);
		    }
		}
	    }
	}
      else
	{
	  ////e[i] = a[i][l];
	  //static_assert(0 <= i);
	  //static_assert(i < e_dim1);
	  //static_assert(0 <= i);
	  //static_assert(i < a_dim1);
	  //static_assert(0 <= l);
	  //static_assert(l < a_dim2);
	}
      //d[i] = h;
      //static_assert(0 <= i);
      //static_assert(i < d_dim1);
    }
  //d[0] = 0.0;
  //static_assert(0 <= 0);
  //static_assert(0 < d_dim1);
  //e[0] = 0.0;
  //static_assert(0 <= 0);
  //static_assert(0 < e_dim1);
  for (i = 0; i < n; i++)
    {
      l = i;
      //static_assert(0 <= i);
      //static_assert(i < d_dim1);
      if (unknown() /*d[i] != 0.0*/)
      {
	for (j = 0; j < l; j++)
	  {
	    // g = 0.0;
	    for (k = 0; k < l; k++)
	      {
		//g += a[i][k] * a[k][j];
		//static_assert(0 <= i);
		//static_assert(i < a_dim1);
		//static_assert(0 <= k);
		//static_assert(k < a_dim2);
		//static_assert(0 <= k);
		//static_assert(k < a_dim1);
		//static_assert(0 <= j);
		//static_assert(j < a_dim2);
	      }
	    for (k = 0; k < l; k++)
	      {
		//a[k][j] -= g * a[k][i];
		//static_assert(0 <= k);
		//static_assert(k < a_dim1);
		//static_assert(0 <= j);
		//static_assert(j < a_dim2);
		//static_assert(0 <= k);
		//static_assert(k < a_dim1);
		//static_assert(0 <= i);
		//static_assert(i < a_dim2);
	      }
	  }
      }
      //d[i] = a[i][i];
      //static_assert(0 <= i);
      //static_assert(i < d_dim1);
      //static_assert(0 <= i);
      //static_assert(i < a_dim1);
      //static_assert(0 <= i);
      //static_assert(i < a_dim2);
      //a[i][i] = 1.0;
      //static_assert(0 <= i);
      //static_assert(i < a_dim1);
      //static_assert(0 <= i);
      //static_assert(i < a_dim2);
      for (j = 0; j < l; j++)
	{
	  //a[j][i] = a[i][j] = 0.0;
	  //static_assert(0 <= j);
	  //static_assert(j < a_dim1);
	  //static_assert(0 <= i);
	  //static_assert(i < a_dim2);
	  //static_assert(0 <= i);
	  //static_assert(i < a_dim1);
	  //static_assert(0 <= j);
	  //static_assert(j < a_dim2);
	}
    }
}
