// Numerical Recipes in C++, 2nd edition, pg. 454

int assume(bool);
int static_assert(bool);
int unknown();

void
//NR::trnspt(Vec_IO_INT & iorder, Vec_I_INT & n)
function()
{
  int iorder_dim1;
  assume(iorder_dim1 > 0);
  int n_dim1;
  assume(n_dim1 >= 6);

  int m1, m2, m3, nn, j, jj;

  int ncity = iorder_dim1;
  // Vec_INT jorder(ncity);
  int jorder_dim1 = ncity;

  //m1 = (n[1] - n[0] + ncity) % ncity;
  //static_assert(0 <= 1);
  //static_assert(1 < n_dim1);
  //static_assert(0 <= 0);
  //static_assert(0 < n_dim1);
  assume(m1 >= 0);
  assume(m1 < ncity);

  //m2 = (n[4] - n[3] + ncity) % ncity;
  //static_assert(0 <= 4);
  //static_assert(4 < n_dim1);
  //static_assert(0 <= 3);
  //static_assert(3 < n_dim1);
  assume(m2 >= 0);
  assume(m2 < ncity);

  //m3 = (n[2] - n[5] + ncity) % ncity;
  //static_assert(0 <= 2);
  //static_assert(2 < n_dim1);
  //static_assert(0 <= 5);
  //static_assert(5 < n_dim1);
  assume(m3 >= 0);
  assume(m3 < ncity);

  assume(m1 + m2 + m3 + 3 == iorder_dim1);
  
  nn = 0;
  for (j = 0; j <= m1; j++)
    {
      //jj = (j + n[0]) % ncity;
      //static_assert(0 <= 0);
      //static_assert(0 < n_dim1);
      assume(jj >= 0);
      assume(jj < ncity);
      //jorder[nn++] = iorder[jj];
      //static_assert(0 <= nn);
      //static_assert(nn < jorder_dim1);
      //static_assert(0 <= jj);
      //static_assert(jj < iorder_dim1);
      nn++;
    }
  for (j = 0; j <= m2; j++)
    {
      //jj = (j + n[3]) % ncity;
      //static_assert(0 <= 3);
      //static_assert(3 < n_dim1);
      assume(jj >= 0);
      assume(jj < ncity);
      //jorder[nn++] = iorder[jj];
      //static_assert(0 <= nn);
      //static_assert(nn < jorder_dim1);
      //static_assert(0 <= jj);
      static_assert(jj < iorder_dim1);
      nn++;      
    }
  for (j = 0; j <= m3; j++)
    {
      //jj = (j + n[5]) % ncity;
      //static_assert(0 <= 5);
      //static_assert(5 < n_dim1);
      assume(jj >= 0);
      assume(jj < ncity);
      //jorder[nn++] = iorder[jj];
      //static_assert(0 <= nn);
      //static_assert(nn < jorder_dim1);
      //static_assert(0 <= jj);
      //static_assert(jj < iorder_dim1);
      nn++;
    }
  for (j = 0; j < ncity; j++)
    {
      //iorder[j] = jorder[j];
      //static_assert(0 <= j);
      //static_assert(j < iorder_dim1);
      //static_assert(0 <= j);
      //static_assert(j < jorder_dim1);
    }
}
